; GW48_3_ASM on J16
; and win1_ass
; 18th March 1999
;
; DCB altered to allow a string constant - 18th March 1999
;
; DCB altered to allow large counts - 31st January 1999
;     and to correct DCB.B
;
; Macro LK for PR31 altered call - Dec 98
;
; An ASSEMBLER program
;    PART 3
;
; The programs for each instruction
;  PR_EQ & PR1 to PR110
;
; This covers all the instructions
;  for the 68000 series
;
; It can only be run on a 68020 or above
;
; REG (D2.W = 2), EQUR (D2.W = $FD)/D7.W=0, FEQUR (D2.W = $FD)/D7.W=1
; EQU (D2.W = 0), SET (D2.W = 1), RS (D2.W = $FE) & FREG (D2.W = $FC)
;
; SET labels have bit 6 of TYPE set. Only a SET label can be altered.
; REG labels have bit 8 of TYPE set. They cannot be in EQU lists or
; unknown.
;
;  MARK = 0 for no previous label
;	1 for new label
;	2 for SET label (type 5)
;	4 for XREF label or SET label (wrong type)
;	5 for undetermined label
;
PR_EQ	MOVE.L	A5,PC_NOW(A6)	set *
	BFEXTU	MARK(A6){14:2},D4	MARK&3
	BNE	PR_EQ2		not error
;
	CLR.W	MARK(A6)		(in case MARK = 4)
	BRA	PR_E4	---->
;
PR_EQ2	MOVE.W	D2,D6	keep REG/SET/EQU marker in D6
	CMPI.W	#1,D6
	BEQ	PR_EQ1
	CMPI.W	#2,D4
	BEQ	PR_E23	---->	label defined 2x
PR_EQ1	MOVE.W	2+MARK(A6),D1
	BSR	LNPTR
	MOVEA.L	A0,A2	----> LINN
	CLR.W	MARK(A6)	    clear MARK
	CMPI.B	#$FC,D2	RS, FREG, EQUR or FEQUR? . .
	BCC	PR0_RS	. . yes
	CMPI.B	#32,D0	space after EQU?
	BEQ.S	PR_EQS	yes
	CMPI.B	#9,D0	TAB
	BNE	PR_E19 ----> not TAB or SPACE
PR_EQS	CMPI.B	#32,(A1)+
	BEQ.S	PR_EQS
	CMPI.B	#9,-1(A1)
	BEQ.S	PR_EQS
	MOVE.B	-1(A1),D0 1st character of num
	CMPI.W	#2,D6
	BEQ	PR_EQR	REG (reg list)
	MOVE.B	#13,SIZE(A6) set size to X in case FP input
	BSR	GNUM1	FPs are set to type X
	TST.W	D6
	BNE	PR_SET
	TST.B	D1
	BMI	PR_EQF	could be FP number
	BEQ.S	PR_EQL	type unknown
	CMPI.B	#2,D1
	BEQ.S	PR_EQL	type 'PC'
	CMPI.B	#4,D1
	BEQ.S	PR_LAB
PR_EQS1	MOVE.L	D2,VAL(A2)
PR_EQS2	ANDI.W	#$1003,TYPE(A2)	keep XDEF if there
	ORI.W	#5,TYPE(A2)	set type N
	BRA	INST_ED1
;
PR_EQL	ADDQ.W	#8,D1	mark EQlist
	MOVE.B	D1,TYPE+1(A2)  set LABEL -> EQlist and leave XDEF
	MOVEQ	#12,D1	12 bytes needed for entry
	BSR	NN_LG2
	MOVE.L	A0,VAL(A2)
	LEA	6(A0),A0
	TST.L	D2
	BMI.S	PR_EQLM
	MOVEQ	#1,D6
	BRA.S	PR_EQLP
PR_EQLM	MOVEQ	#-1,D6
PR_EQLP	MOVE.W	D6,(A0)+	+ or -
	MOVE.W	D2,(A0)+	EQlist pointer
	CLR.W	(A0)+	mark end of EQU list entry
	BRA	INST_ED1
;
PR_LAB	BCLR	#31,D2
	MOVE.L	D2,VAL(A2)
	ANDI.W	#$1003,TYPE(A2)	keep type and XDEF
	ORI.W	#8,TYPE(A2)
	BRA	INST_ED1
;
PR_EQR	MOVE.W	#$105,D3
	LEA	PR7_GA,A4
	SUBQ.L	#1,A1	reset pointer -> list
PR_EQR1	TST.W	TYPE(A2)
	BNE	PR_E5	---->
	MOVEQ	#0,D6	get ready for reg list
	JSR	(A4)	get reg list
	BMI	PR_E22	---->
	MOVE.W	D3,TYPE(A2)
	MOVE.L	D6,VAL(A2)
	BRA	INST_ED1
;
PR0_FREG	MOVE.W	#$305,D3
	LEA	PR63_L,A4
	BRA	PR_EQR1
;
PR0_RS	BEQ	PR0_FREG
	CMPI.B	#$FD,D2
	BEQ	PR0_RG
	BSR	GNUM	get number
	SUBQ.L	#1,D1
	BNE	PR_E1	---->
	MOVE.B	SIZE(A6),D3
	CMPI.W	#3,D3
	BLT	PR0_RS1
	SUBQ.W	#8,D3
	CMPI.W	#7,D3
	BLT	PR0_RS1
	MOVEQ	#7,D3
;
; Now D3 = 0 to 7 for  B, W, L, S, D, X, P, Q
;
PR0_RS1	MULS.L	RS_TBLE(D3.W*4),D2	RS increment
	BVS	PR_E2	---->	too big
	BEQ	PR_E6	---->	too small
	MOVE.L	RS(A6),D3
	MOVE.L	D3,VAL(A2)	set value of label
	ADD.L	D2,D3		new value of RS
	BVS	PR_E2	---->	too big
	MOVE.L	D3,RS(A6) update RS
	BRA	PR_EQS2
;
RS_TBLE	DC.L	1,2,4,4,8,12,12,16
;
; To set label = register
;
PR0_RG	TST.W	D7
	BNE	PR0_FRG	FEQUR
	MOVEQ	#16,D1
	BSR	EA_GTR
	BMI	PR_E13	---->
	BFTST	D1{0:16}
	BNE	PR_E13	----> should not be size
PR0_RG1	MOVE.L	D1,VAL(A2)
	TST.W	TYPE(A2)
	BNE	PR_E5	---->
	MOVE.W	#$205,TYPE(A2)
	BRA	INST_ED1
;
PR0_FRG	BSR	GET_FP
	BMI	PR_E13	---->
	ADD.W	#21,D1	set value as for EA_01
	BRA	PR0_RG1
;
PR_EQF	BTST	#4,TYPE(A2)	XDEF? . . .
	BNE	PR_E5	---->	. . . yes
	CMPI.B	#-2,D1
	BEQ	PR_EQFSR	string
	CMPI.B	#-4,D1
	BEQ	PR_EQQA	quad word
	CMPI.B	#-3,D1	FP?
	BNE	PR_E1	----> error in no
	MOVE.W	#$15,TYPE(A2)
	MOVEQ	#12,D1
	BSR	NN_LG2
	MOVE.L	BUF(A6),(A0)	set count
	MOVE.L	BUF+4(A6),4(A0)
	MOVE.L	BUF+8(A6),8(A0)
PR_EQF2	MOVE.L	A0,VAL(A2)
PR_EQF3	TST.W	D6
	BEQ	INST_ED1		EQU
	BSET	#6,TYPE+1(A2)	set SET bit
	BRA	INST_ED1
;
PR_EQFSR	BSR	PUT_STRG
	BRA	PR_EQF3
;
PR_EQQA	MOVEQ	#8,D1
	BSR	NN_LG2
	MOVE.L	BUF+4(A6),(A0)
	MOVE.L	BUF+8(A6),4(A0)
	MOVE.W	#$25,TYPE(A2)	set type quad
	BRA	PR_EQF2
PR_SET	TST.B	D1
	BMI	PR_EQF	FP or string
	CMPI.B	#1,D1
	BNE	PR_E24	---->	label not defined
	MOVE.L	D2,VAL(A2)	set new value
	MOVE.B	#$45,1+TYPE(A2)	set to SET type N
	BRA	INST_ED1
;
PR_W17	MOVEQ	#-17,D1
	BRA	DO_ERR
PR_W16	MOVEQ	#-16,D1
	BRA	DO_ERR
PR_W15	MOVEQ	#-15,D1
	BRA	DO_ERR
PR_W11	MOVEQ	#-11,D1
	BRA	DO_ERR
PR_W9	MOVEQ	#-9,D1
	BRA	DO_ERR
PR_W7	MOVEQ	#-7,D1
	BRA	DO_ERR
PR_W6	MOVEQ	#-6,D1
	BRA	DO_ERR
PR_W5	MOVEQ	#-5,D1
	BRA	DO_ERR
PR_W4	MOVEQ	#-4,D1
	BRA	DO_ERR
PR_W3	MOVEQ	#-3,D1
PR_WXX	BRA	DO_ERR
PR_E1	MOVEQ	#1,D1
PR_EXX	BSR	DO_ERR
	LEA	EXTBUF+4(A6),A0
	MOVE.L	A0,-4(A0) reset EXTBUF
	BRA	INST_ED2
PR_E2	MOVEQ	#2,D1
	BRA.S	PR_EXX
PR_E3	MOVEQ	#3,D1
	BRA.S	PR_EXX
PR_E4	MOVEQ	#4,D1
	BRA.S	PR_EXX
PR_E5	MOVEQ	#5,D1
	BRA.S	PR_EXX
PR_E6	MOVEQ	#6,D1
	BRA.S	PR_EXX
PR_E7	MOVEQ	#7,D1
	BRA.S	PR_EXX
PR_E8	MOVEQ	#8,D1
	BRA.S	PR_EXX
PR_E9	MOVEQ	#9,D1
	BRA.S	PR_EXX
PR_E10	MOVEQ	#10,D1
	BRA.S	PR_EXX
PR_E11	MOVEQ	#11,D1
	BRA.S	PR_EXX
PR_E12	MOVEQ	#12,D1
	BRA.S	PR_EXX
PR_E13	MOVEQ	#13,D1
	BRA.S	PR_EXX
PR_E14	MOVEQ	#14,D1
	BRA.S	PR_EXX
PR_E15	MOVEQ	#15,D1
	BRA.S	PR_EXX
PR_E16	MOVEQ	#16,D1
	BRA.S	PR_EXX
PR_E17	MOVEQ	#17,D1
	BRA.S	PR_EXX
PR_E18	MOVEQ	#18,D1
	BRA.S	PR_EXX
PR_E19	MOVEQ	#19,D1
	BRA.S	PR_EXX
PR_E20	MOVEQ	#20,D1
	BRA.S	PR_EXX
PR_E21	MOVEQ	#21,D1
	BRA.S	PR_EXX
PR_E22	MOVEQ	#22,D1
	BRA.S	PR_EXX
PR_E23	MOVEQ	#23,D1
	BRA.S	PR_EXX
PR_E24	MOVEQ	#24,D1
	BRA.S	PR_EXX
PR_E25	MOVEQ	#25,D1
	BRA.S	PR_EXX
PR_E26	MOVEQ	#26,D1
	BRA.S	PR_EXX
PR_E27	MOVEQ	#27,D1
	BRA	PR_EXX
PR_E28	MOVEQ	#28,D1
	BRA	PR_EXX
PR_E29	MOVEQ	#29,D1
	BRA	PR_EXX
PR_E30	MOVEQ	#30,D1
	BRA	PR_EXX
PR_E38	MOVEQ	#38,D1
	BRA	PR_EXX
PR_E39	MOVEQ	#39,D1
	BRA	PR_EXX
PR_E40	MOVEQ	#40,D1
	BRA	PR_EXX
PR_E41	MOVEQ	#41,D1
	BRA	PR_EXX
PR_E42	MOVEQ	#42,D1
	BRA	PR_EXX
PR_E43	MOVEQ	#43,D1
	BRA	PR_EXX
PR_E44	MOVEQ	#44,D1
	BRA	PR_EXX
PR_E45	MOVEQ	#45,D1
	BRA	PR_EXX
PR_E46	MOVEQ	#46,D1
	BRA	PR_EXX
PR_E47	MOVEQ	#47,D1
	BRA	PR_EXX
PR_E48	MOVEQ	#48,D1
	BRA	PR_EXX
PR_E49	MOVEQ	#49,D1
	BRA	PR_EXX
PR_E50	MOVEQ	#50,D1
	BRA	PR_EXX
PR_E51	MOVEQ	#51,D1
	BRA	PR_EXX
PR_E56	MOVEQ	#56,D1
	BRA	PR_EXX
PR_E57	MOVEQ	#57,D1
	BRA	PR_EXX
PR_E58	MOVEQ	#58,D1
	BRA	PR_EXX
PR_E60	MOVEQ	#60,D1
	BRA	PR_EXX
PR_E61	MOVEQ	#61,D1
	BRA	PR_EXX
PR_E62	MOVEQ	#62,D1
	BRA	PR_EXX
PR_E64	MOVEQ	#62,D1
	BRA	PR_EXX
PR_E65	MOVEQ	#65,D1
	BRA	PR_EXX
PR_E66	MOVEQ	#66,D1
	BRA	PR_EXX
PR_E68	MOVEQ	#68,D1
	BRA	PR_EXX
PR_E69	MOVEQ	#69,D1
	BRA	PR_EXX
PR_E70	MOVEQ	#70,D1
	BRA	PR_EXX
PR_E71	MOVEQ	#71,D1
	BRA	PR_EXX
PR_E72	MOVEQ	#72,D1
	BRA	PR_EXX
PR_E73	MOVEQ	#73,D1
	BRA	PR_EXX
PR_E80	MOVEQ	#80,D1
	BRA	PR_EXX
PR_E81	MOVEQ	#81,D1
	BRA	PR_EXX
PR_E83	MOVEQ	#83,D1
	BRA	PR_EXX
;
; NOP, RTS, RESET, RET, RTR, PFLUSHA
;
PR1	BRA	INST_END
;
; Bcc, BSR
;
; D7.L = 0 for Bcc & BSR but = $50 for FBcc
;
PR2	ADD.W	D1,D7	0=short 1=Wd 2=long 3=variable
PR2_E	BSR	GNUM	DBcc from PR3 enters here with D7 = 1
	TST.B	D1
	BMI	PR_E1 ---->
	BEQ.S	P2_LAB
	CMPI.B	#2,D1
	BMI	PR_E5 ---->
	BGT	P2_DUM	do dummy label
	BRA.S	P2_INS
P2_SE1	ADDQ.L	#2,A5
	BSR	PUT_W
	MOVEQ	#0,D5
P2_SE2	DBF	D7,P2_SE1
	BRA	INST_END
P2_LAB	MOVE.W	D2,D1	label no
	BSR	LNPTR	A0 -> LINN
	BSET	#1,TYPE+1(A0)	mark PC
P2_INS	MOVEQ	#2,D6
	BSR	PR2_GSP
	MOVE.L	A5,D1
	BFEXTS	D7{30:2},D4
	BEQ.S	P2_INSM
	ADDI.L	#1,D4
	BNE.S	P2_INSL	not variable
	BTST	#6,D7	1 = FBcc 0 = Bcc, BSR
	BNE.S	PR2_1
	ADDI.L	#$84000000,D1	compress up to 4
	MOVEQ	#14,D7
	BRA.S	P2_INSL
PR2_1	ADDI.L	#$82000000,D1	compress up to 2
	MOVEQ	#$4E,D7
	BRA.S	P2_INSL
P2_INSM	SUBQ.L	#2,D1
	MOVEQ	#4,D6
P2_INSL	MOVE.L	D1,(A0)+	PC
	MOVE.W	D2,(A0)+	LAB No
	MOVE.B	D6,(A0)+	w
	MOVE.B	#10,D6
	ADD.B	D7,D6	10, 11 or 12 (+ $50 for FBcc)
	MOVE.B	D6,(A0)+	type
	ANDI.B	#$F,D7
	CMPI.B	#14,D7
	BNE.S	P2_SE2	not variable
	MOVEQ	#2,D7	set LONG
	BRA.S	P2_SE2
P2_DUM	BSR	SDUM	sets A0 -> LINN - lab no -> D3.W
	BMI	PR_E8	---->
	MOVE.W	#10,TYPE(A0)	type PC|EQlist
	MOVE.L	D2,VAL(A0)
	MOVE.L	D3,D2	set LAB No to D2 for INS
	BRA	P2_INS
;
PR2_GSP	BSR	GBINS	arranges that there is 10 bytes there
	MOVEA.L	([BINS,A6]),A0	start of free area
	ADDI.L	#10,([BINS,A6])	advance address
	MOVE.W	CRT_SEC(A6),8(A0)	set section number
	RTS
;
; DBcc
;
PR3
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	MOVEQ	#1,D7	mark LONG
	BRA	PR2_E
;
; ASL, ASR, LSL, LSR, ROL, ROR, ROXL, ROXR
;
PR4	LSL.W	#6,D1
	OR.W	D1,D5
	MOVE.B	#3,SIZE(A6)
	MOVEQ	#0,D6	mark 'not immediate'
	CMPI.B	#"#",(A1) immediate? . . .
	BNE	PR4_1	. . . no
	MOVEQ	#1,D6	mark 'immediate'
	SUBQ.L	#2,A5
PR4_1	BSR	EA
	TST.L	D6	immediate? . . .
	BEQ	PR4_2	. . . no
	ADDQ.L	#2,A5
PR4_2	MOVE.W	D2,D3
	ANDI.W	#$3F,D3
	CMPI.W	#$3C,D3	7(4)?
	BEQ.S	PR4_74	yes
	CMPI.W	#8,D3	D?
	BLT.S	PR4_D	yes
	MOVE.W	D5,D4
	ANDI.W	#$18,D4
	LSL.W	#6,D4
	OR.W	D4,D5
PR4_ZR	ANDI.W	#$FFC0,D5 clear <ea>
	OR.W	D3,D5
	ORI.W	#192,D5
	BRA	INST_END
PR4_D	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	ORI.W	#32,D5
	ANDI.W	#$FFF8,D5 clear reg
PR4_74	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	BRA	INST_END
;
; MOVE
;
PR5	MOVE.B	D1,D6	& keep size in D6
	BSR	MOTR
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	CMPI.B	#$38,D2	mode 7?
	BNE.S	PR5_NOR	not mode 7
	ANDI.W	#7,D3	reg
	CMPI.W	#5,D3
	BGE.S	PR5_SCU	SR, CCR or USP
PR5_NOR	SWAP	D7
	MOVE.B	#2,F_EA(A6)  2nd EA
	BSR	MOTR
	SF	F_EA(A6)	clear F_EA
	CMPI.B	#$38,D2	mode 7?
	BNE.S	PR5_NORX
	MOVE.W	D3,D4	keep mode|reg
	ANDI.W	#7,D3
	CMPI.W	#5,D3
	BGE.S	PR5_SCU1
PR5_NORX	MOVE.W	#$1000,D1
	CMPI.B	#1,D6
	BMI.S	PR5_NORB
	BGT.S	PR5_NORL
	ADD.W	D1,D1
PR5_NORL	ADDI.W	#$1000,D1
PR5_NORB	OR.W	D1,D5
	LSL.W	#3,D2	mode
	OR.W	D2,D5
	ANDI.W	#7,D3	reg
	ADD.W	D3,D3
	LSL.W	#8,D3
	OR.W	D3,D5
	BRA	INST_END
PR5_SCU	BEQ.S	PR5_SR
	CMPI.W	#6,D3
	BEQ.S	PR5_CCR
	MOVE.W	#$4E68,D5
	MOVE.W	MSEVA,D7
	BSR	MOTR2
	ANDI.B	#7,D2
	OR.B	D2,D5
	BRA	INST_END
PR5_SR	MOVE.W	#$40C0,D5
PR5_SR1	MOVE.W	MSEV,D7
	PEA	INST_END
	BRA.S	MOTR2
PR5_CCR	MOVE.W	#$42C0,D5
	BRA.S	PR5_SR1
;
MSEV	DC.W	$FE02	all but A & enter it
MSEVA	DC.W	$7FFD	only A (not entered)
;
PR5_SCU1	MOVE.W	D4,D2	set mode|reg
	BFEXTU	D5{26:3},D4         mode of 1st <ea>
	CMPI.B	#7,D3
	BEQ	PR5_USP1		USP
	CMPI.B	#1,D4		An? . .
	BEQ	PR_E14	---->	. . yes
	ANDI.W	#$3F,D5	keep mode|reg
	CMPI.W	#$3C,D5	is it immediate? . .
	BNE	PR5_SCU2	. . no
	MOVE.W	D6,D4	size
	MOVE.W	D3,D0
	BSR	PR8_SR	to check size
	MOVE.W	D0,D3
PR5_SCU2	OR.W	PR5_TBL-10(D3.W*2),D5
	BRA	INST_END
;
PR5_USP1	CMPI.B	#1,D4		An? . .
	BNE	PR_E14	---->	. . no
	ANDI.W	#7,D5
	BRA	PR5_SCU2
;
PR5_TBL	DC.W	$46C0,$44C0,$4E60
;
MOTR	MOVE.B	#2,ER_EA(A6) to adjust stack 2 words if error
	BSR	EA
	MOVE.W	D2,D3
	ANDI.W	#$38,D2	mode
	CMPI.B	#$8,D2	A?
	BNE.S	MOTR1	no
	TST.B	D6
	BNE.S	MOTR1
	ADDQ.L	#4,A7
	BRA	PR_E16 ---->
MOTR1	RTS
;
MOTR2	MOVE.B	#2,F_EA(A6)
	MOVE.B	#2,ER_EA(A6)
	BSR	EA
	CLR.B	F_EA(A6)
	RTS
;
; ADD, SUB, OR, AND, CMP
;
PR6	MOVE.B	D1,D4
	LSL.W	#6,D1
	OR.W	D1,D5
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	ANDI.W	#$38,D2
	BNE.S	PR6_EA	not Dn
	SWAP	D7
	BSR	EA
	MOVE.W	D2,D3
	CMPI.B	#15,D2
	BGT	PR6_EA6	not Dn or An
	CMPI.B	#8,D2
	BGE	PR6_EA5	An
	BRA	PR6_EA1
;
PR6_EA6	MOVE.W	D5,D3
	ANDI.W	#$FFC0,D5 delete <ea>
	ANDI.W	#7,D3	keep reg
	ADD.W	D3,D3
	LSL.W	#8,D3
	OR.W	D3,D5
	ANDI.W	#$3F,D2	<ea>
	ADDI.W	#256,D2
	BRA.S	PR6_EA2
;
PR6_EA	CMPI.W	#8,D2
	BNE.S	PR6_EA3	not A
	TST.B	D4
	BEQ	PR_E16 ---->
PR6_EA3	MOVE.W	D5,D3
	ANDI.W	#$3F,D3
	CMPI.W	#$3C,D3
	BEQ	PR6_1	#
	ANDI.W	#$38,D3
	CMPI.W	#$18,D3
	BEQ	PR6_2	(An)+
PR6_5	BTST	#12,D5
	BNE	PR6_3	not AND/OR
	MOVE.W	#PR6_d,D7
	BRA	PR6_EA4
;
; The values of D7.W set to a - e all exclude PC and Immediate <ea>s.
; The remaining possibilties are set as follows:
PR6_a	EQU      $4E02    Allow CCR, SR and all others save A and USP
PR6_b	EQU      $7E00    Allow all save USP, CCR and SR
PR6_c	EQU      $7FF4    Allow only A, D and (An)+
PR6_d	EQU      $7FFE    Allow only D
PR6_e	EQU      $7FFC    Allow only A and D
;
PR6_1	BTST	#12,D5
	BNE	PR6_4	not AND/OR
	MOVE.W	#PR6_a,D7
	BRA	PR6_EA4
;
PR6_2	BTST	#13,D5
	BEQ	PR6_5	not CMP
	MOVE.W	#PR6_c,D7
	BRA	PR6_EA4
;
PR6_4	MOVE.W	#PR6_b,D7
	BRA	PR6_EA4
;
PR6_3	MOVE.W	#PR6_e,D7
PR6_EA4	BSR	EA
	MOVE.W	D2,D3
	CMPI.W	#PR6_c,D7
	BEQ	PR6_6
	CMPI.W	#PR6_d,D7
	BNE	PR6_7
PR6_EA4A	CMPI.B	#8,D2
	BLT.S	PR6_EA1	Dn
PR6_EA5	TST.B	D4
	BEQ	PR_E16	---->
	ADDI.W	#$80,D5
	ORI.W	#$C0,D5	set op-mode for A
PR6_EA1	ANDI.W	#7,D2
	ADD.W	D2,D2
	LSL.W	#8,D2
PR6_EA2	OR.W	D2,D5
	BRA	INST_END
;
PR6_6	ANDI.W	#%111000,D3
	CMPI.W	#%011000,D3
	BNE	PR6_EA4A	not (An)+
;
; Now set CMPM
;
	BCLR	#4,D5
	BSET	#8,D5
	BFINS	D2,D5{20:3}
	BRA	INST_END
;
PR6_8	BSR	PR8_SR	check and set size
	MOVE.W	D5,D4
	MOVE.W	#$3C,D5
	BFINS	D2,D5{25:1}         set SR or CCR
	BTST	#14,D4
	BEQ	INST_END	'OR'
	BSET	#9,D5	set 'AND'
	BRA	INST_END
;
PR6_7	ANDI.W	#%111111,D3
	CMPI.W	#%111101,D3
	BGE	PR6_8	set ..I SR/CCR
	CMPI.W	#%010000,D3
	BLT	PR6_EA4A	D/A
;
; Set ..I <ea>
;
	BFEXTU	D5{17:3},D4
	MOVE.B	PR6_IT(D4.W),D4
	BFINS	D4,D5{16:8}         set OR/SUB . . etc
	BFINS	D2,D5{26:6}         set <ea>
	BRA	INST_END
;
; This table contains the contents of bits 8 - 11 of D5
;
PR6_IT	DC.B	%0000	OR
	DC.B	%0100	SUB
	DC.B	0	 -
	DC.B	%1100	CMP
	DC.B	%0010	AND
	DC.B	%0110	ADD
	DC.B	0,0	 -
;
; MOVEM
;
PR7	BSET	#31,D5
	MOVEQ	#0,D6	prepare for reg list
	SUBQ.W	#1,D1
	BMI	PR_E16 ---->
	LSL.W	#6,D1
	OR.W	D1,D5
	MOVE.B	#%111101,F_EA(A6) allow all seps and jump [EXT]
PR7_1	BSR	EA
	CMPI.B	#16,D2	A/D? . .
	BLT.S	PR7_3	. . yes
	BFEXTU	D2{26:6},D3
	CMPI.W	#$3C,D3	7(4)
	BNE	PR7_2	not label reg list
	MOVE.W	([OBUF,A6],-2),D6	get reg list to D6
	SUBQ.L	#2,OBUF(A6)	reduce OBUF
	SUBQ.L	#2,A5		and step backPC
	BRA	PR7_4
;
; A/D list specifically
;
PR7_3	MOVE.B	D2,D1
	SUBQ.L	#1,A1
	BSR	PR7_AD1		get reg list
	BMI	PR_E22 ---->
PR7_4	BCLR	#31,D5		clear 1st time marker
	BEQ	PR7_FL1A		end
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	MOVE.B	#1,F_EA(A6)
	BRA	PR7_1
;
PR7_2	BCLR	#31,D5
	BEQ	PR7_FL1A
	CMPI.B	#',',D0
	BNE	PR_E19	---->
	BSET	#10,D5	mark mem->reg
	OR.B	D2,D5
	MOVE.W	#$7FFC,D7 get D/A
	BRA	PR7_1
;
PR7_GA	MOVEQ	#16,D1
	BSR	EA_GTR	get reg to D1
	BMI	PR7_GAE	---->
	SUBQ.L	#1,A1	set A1 -> separator
	MOVE.B	D1,D2
PR7_AD1	BSET	D1,D6
PR7_AD2	MOVE.B	(A1)+,D0
	CMPI.B	#"/",D0
	BEQ.S	PR7_GA
	CMPI.B	#"-",D0
	BEQ.S	PR7_GR
PR7_GEX1	MOVE	#0,CCR	set non-negative
PR7_GEX	RTS
;
PR7_GAE	MOVE	#8,CCR	set negative
	BRA	PR7_GEX
;
PR7_GR	TST.B	D2
	BMI	PR7_GAE ---->
	MOVE.B	(A1)+,D0
	CMPI.B	#57,D0
	BGT.S	PR7_GRL
	MOVE.B	D2,D1
	ANDI.B	#8,D1	D or A -> D1
	BSR.S	PR7_NUL
	BRA.S	PR7_GRA
PR7_GRL	BSR.S	PR7_SRL
	BMI	PR7_GEX ---->
PR7_GRA	MOVE.B	D2,D0
	EOR.B	D1,D0
	BTST	#3,D0
	BNE	PR7_GAE ---->
	CMP.B	D1,D2
	BLT.S	PR7_GRB
	EXG	D1,D2	allow eg D6-1
	SUBQ.B	#1,D1
	SUBQ.B	#1,D2
PR7_GRB	ADDQ.B	#1,D2
	BSET	D2,D6
	CMP.B	D1,D2
	BLT.S	PR7_GRB
	MOVEQ	#-1,D2
	BRA.S	PR7_AD2
;
PR7_FL1A	ADDQ.L	#2,A5	PC + 2
	BSR	PUT_W
	AND.W	#$38,D5
	CMPI.W	#$20,D5	mode 4?
	BEQ.S	PR7_REV	yes
PR7_FL1B	MOVE.W	D6,D5
	BRA	INST_END
;
PR7_SRL	SUBI.B	#68,D0
	BLE.S	PR7_SR1
	SUBI.B	#32,D0
PR7_SR1	BEQ.S	PR7_SR2
	ADDI.B	#11,D0
	CMPI.B	#8,D0	    A?
	BNE.S	PR7_GAE ----> no
PR7_SR2	MOVE.B	D0,D1
	MOVE.B	(A1)+,D0
PR7_NUL	SUBI.B	#48,D0
	BLT.S	PR7_GAE ---->
	CMPI.B	#7,D0
	BGT.S	PR7_GAE ---->
	ADD.B	D0,D1
	BRA	PR7_GEX1
;
PR7_REV	MOVEQ	#15,D0
	MOVEQ	#0,D5
PR7_REV1	LSR.W	#1,D6
	BCC.S	PR7_REV2
	BSET	D0,D5
PR7_REV2	DBF	D0,PR7_REV1
	BRA	INST_END
;
; ADDI, ANDI, CMPI, EORI, ORI, SUBI
;
PR8	MOVE.B	D1,D4	keep size in D4
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	CMPI.B	#$3D,D2	CCR, SR?
	BLT.S	PR8_D	no
	BSR	PR8_SR	check and set correct size
PR8_A1	BCLR	#0,D5
	BEQ.S	PR8_A
	BSET	#6,D5
PR8_A	BCLR	#1,D5
	BRA	INST_END
PR8_D	LSL.B	#6,D4
PR8_1	OR.B	D4,D5	insert size
	BRA	INST_END
;
PR8_SR	CMPI.B	#2,D4
	BEQ	PR8_E16	---->
	MOVE.L	BINS(A6),D6
	BEQ	PR8_2	no INSERTs yet
	BFEXTU	([D6.L],-10){8:24},D3      PC
	ADDQ.L	#2,D3	adjust for word
	CMP.L	A5,D3	INSERT for this instruction? . .
	BNE	PR8_2	. . no
	MOVEQ	#3,D3
	CMPI.B	#$3D,D2
	BEQ	PR8_3	SR
	SUBQ.W	#1,D3	CCR
PR8_3	BFINS	D3,([D6.L],-3){5:3}     set size
	BRA	PR8_SR1
PR8_2	CMPI.B	#$3D,D2
	BEQ	PR8_SR1	SR
	MOVE.W	D2,D3
	MOVE.W	OBUF+4(A6),D2
	BSR	CMP_B
	BMI	PR8_E2	---->
	MOVE.W	D3,D2
PR8_SR1	RTS
;
PR8_E16	ADDQ.L	#4,A7
	BRA	PR_E16
PR8_E2	ADDQ.L	#4,A7
	BRA	PR_E2
;
; ABCD, ADDX, CMPM, SBCD, SUBX
;
PR9	TST.B	D1
	BMI.S	PR9_S
	LSL.W	#6,D1
	OR.W	D1,D5
PR9_S	BSR	EA
	ANDI.W	#$38,D2
	BEQ.S	PR9_D
	ANDI.W	#$FFC7,D5 clear mode
	ORI.W	#8,D5
	BRA.S	PR11_E
PR9_D	MOVE.W	#$7FFE,D7
	BRA.S	PR11_D
;
; ADDQ, SUBQ
;
PR10	LSL.W	#6,D1
	OR.W	D1,D5
	MOVE.B	#3,SIZE(A6)
	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	ANDI.W	#$38,D2
	CMPI.W	#$8,D2
	BNE	INST_END
	MOVE.W	D5,D2
	ANDI.W	#192,D2
	BEQ	PR_E16 ---->
	BRA	INST_END
;
; ADDA, SUBA, CMPA
;
PR11	TST.B	D1
	BEQ	PR_E16 ---->
PR11_F	MOVE.B	D1,SIZE(A6)
	BTST	#1,D1
	BEQ.S	PR11_C
	BSET	#8,D5	set L
PR11_C	BSR	EA	CHK, MOVEA enter here
PR11_E	SWAP	D7
PR11_D	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	BSR	EA
	ANDI.W	#7,D2
	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BRA	INST_END
;
; BCHG, BCLR, BSET, BTST
;
PR12	CMPI.B	#1,D1	W? ...
	BEQ	PR_E16	... yes ---->
	MOVE.B	D1,D6	size to D6
	CLR.B	SIZE(A6)
	BSR	EA
	MOVE.W	D2,D3
	ANDI.W	#$38,D3
	BNE.S	PR12_74
	BSET	#8,D5
	ANDI.W	#7,D2
PR12_E	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BRA.S	PR12_D
PR12_74	BSET	#11,D5
PR12_D	CMPI.B	#",",D0	PR38 (CALLM) enters here with D6=-1
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	TST.B	D6	size
	BMI	INST_END	OK
	ANDI.W	#$38,D2
	BEQ.S	PR12_2	Dn
	TST.B	D6
PR12_1	BEQ	INST_END	OK
	BRA	PR_E16	---->
PR12_2	CMPI.B	#2,D6	L?
	BRA.S	PR12_1
;
; CHK, DIVS, DIVU, MULS, MULU, LEA
;
PR13	MOVEQ	#1,D1	set SIZE = WORD
	BRA	PR11_F
;
; CLR, JMP, JSR, NBCD, NEG, NEGX, NOT, PEA, Scc, TAS, TST
;
PR14	MOVE.B	D1,D3	keep size
	BMI.S	PR14_B
PR14_C	LSL.W	#6,D1
	OR.W	D1,D5
PR14_B	BSR	EA
	ANDI.W	#$38,D2	mode
	CMPI.B	#8,D2
	BNE	INST_END	not An
;
; This can only be TST, UNLK
;
	TST.B	D3
	BNE	INST_END	OK
	BRA	PR_E16	---->
;
; EXT, SWAP, UNLK
;
PR15	MOVE.B	D1,D3
	BMI.S	PR14_B	SWAP, UNLK
	BEQ	PR_E16	---->
	ADDQ.W	#1,D1
	BRA.S	PR14_C
;
; EXG
;
PR16	BSR	EA
	MOVE.W	D2,D3
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	BSR	EA
	BTST	#3,D3
	BEQ	PR16_1	Dn
	EXG	D3,D2	see that 2nd is An
PR16_1	OR.W	D2,D5	enter 2nd reg (An or Dn)
	BFINS	D3,D5{20:3}         enter 1st reg
	BCLR	#3,D2
	BEQ	INST_END	Dn
	BTST	#3,D3
	BNE	INST_END	An
	ADDI.W	#64,D5
	BRA	INST_END
;
; MOVEA
;
PR17	TST.B	D1
	BEQ	PR_E16 ---->
	BTST	#0,D1
	BEQ	PR11_C
	BSET	#12,D5
	BRA	PR11_C
;
; MOVEP
;
PR18	SUBQ.W	#1,D1
	BMI	PR_E16 ---->
	LSL.W	#6,D1
	OR.W	D1,D5
	BSR	EA
PR18_R1	SWAP	D7
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	CMPI.B	#8,D2
	BLT.S	PR18_D
	BSR	EA
	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BCLR	#7,D5
PR18_E	BCLR	#5,D5
	BRA	INST_END
PR18_D	ADD.W	D2,D2	address checked in EA
	LSL.W	#8,D2
	OR.W	D2,D5
	ANDI.W	#$FFC0,D5
	MOVE.W	#$FFDF,D7
	BSR	EA
PR18_R2	BRA.S	PR18_E	address checked in EA
;
; MOVEQ
;
PR19	MOVE.B	#5,SIZE(A6)
	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	BRA	PR11_E
;
; LINK
;
PR20	CMP.B	#1,D1
	BEQ.S	PR20_1	W
	MOVE.W	#$4800,D5 set L version
PR20_1	BSR	EA	bring in An
	BTST	#10,D5
	BEQ.S	PR20_2	L
	BCLR	#3,D5
PR20_2	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	SWAP	D7
	BSR	EA
	BRA	INST_END
;
; STOP
;
PR21	EQU	PR68
;
; TRAP
;
PR22	MOVE.B	#4,SIZE(A6)
PR22_1	SUBQ.L	#2,A5
	BSR	EA
	ADDQ.L	#2,A5
	BRA	INST_END
;
; DS
;
PR23	MOVE.W	D1,D3	 Keep size
	BMI	PR_E1 ---->
	SUBQ.L	#2,A5
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	PR_E1 ---->
	CMPI.W	#10,D3
	BLT	PR23_2	only B W L
	SUBI.W	#9,D3
PR23_2	CMPI.W	#6,D3
	BLT	PR23_3	not Quad word
	MOVEQ	#3,D3	set for x8
PR23_3	LEA	PR23_Z,A0
	ADDA.W	(A0,D3.W*2),A0
	JMP	(A0)
;
PR23_Z	DC.W	PR23_J0-PR23_Z .B
	DC.W	PR23_J0-PR23_Z .W
	DC.W	PR23_J0-PR23_Z .L or .S
	DC.W	PR23_J0-PR23_Z .D or .Q
	DC.W	PR23_J1-PR23_Z .X
	DC.W	PR23_J1-PR23_Z .P
;
PR23_J1	LSL.L	#2,D2
	MOVE.L	D2,D3
	ADD.L	D3,D2
	ADD.L	D3,D2
	BRA	PR23_4
;
PR23_J0	LSL.L	D3,D2 x1 x2 x4 x8 for .B .W .L .D & .Q
PR23_4	MOVE.L	D2,D4	keep no of bytes in D4
	BMI	PR_E6 ---->
;	CMPI.L	#$8000,D4
;	BGE	PR_E6	---->
PR23_1	LEA	O_BEND(A6),A0
	MOVE.L	A0,D1
	LEA	O_BUF+4(A6),A0
	SUB.L	A0,D1  buffer size -> D1
	BSR	PUT_BCT  ouput D4 bytes to BIN
	ADDA.L	D4,A5 set PC *NB may not be on a WORD boundary*
	BRA	INST_ED1
;
; DC
;
PR24	SUBQ.L	#2,A5
	MOVE.W	D1,D3	keep SIZE
PR24_AG	PEA	PR24_5
;
; PR109 enters here - and returns to PR109_1
;
PR24_AG1	MOVE.B	(A1),D0	next character
	CMPI.B	#'"',D0
	BEQ.S	PR24_STG
	CMPI.B	#"'",D0
	BNE	PR24_1	if FP, nos -> ! type
PR24_STG	MOVE.B	#'?',D0	 mark 'string'
	BRA	GNUM1	get in string - even if < 5 bytes
;
PR24_5	TST.B	D1
	BMI	PR24_STR	it might be string, FP or Q
	BEQ	PR24_UL	Unknown LABEL
	CMPI.B	#2,D1
	BEQ	PR24_6	could be relocatable
	BGT	PR24_EQ	EQ list
	MOVE.L	D2,D5
	CMPI.W	#1,D3
	BLT.S	PR24_NB
	BEQ.S	PR24_NW
	SWAP	D5
PR24_NL	ADDQ.L	#2,A5
	BSR	PUT_W
	SWAP	D5
PR24_NW1	ADDQ.L	#2,A5
	BSR	PUT_W
PR24_SE	CMPI.B	#",",D0
	BEQ.S	PR24_AG
	CMPI.B	#10,D0
	BEQ	INST_ED1
	CMPI.B	#32,D0
	BEQ	INST_ED1
	CMPI.B	#9,D0
	BEQ	INST_ED1
	BRA	PR_E1 ---->
PR24_NW	BSR	CMP_W
	BMI	PR_E1 ---->
	BRA.S	PR24_NW1
PR24_NB	BSR	CMP_B
	BMI	PR_E1 ---->
PR24_NB1	ADDQ.L	#1,A5
	BSR	PUT_B
	BRA.S	PR24_SE
PR24_NX	ADDQ.L	#2,A5
	BSR	PUT_W
	ADDQ.L	#2,A5
	BSR	PUT_W
PR24_ND	ADDQ.L	#2,A5
	BSR	PUT_W
	ADDQ.L	#2,A5
	BSR	PUT_W
	BRA	PR24_NL
;
PR24_6	TST.B	REL_SWTCH(A6)
	BEQ	PR_E5	---->
	MOVE.W	CRT_SEC(A6),D5
	CMPI.B	#2,CO_SE(A6,D5.W)
	BEQ	PR24_UL	OK if ORG
	CMPI.B	#2,D3	size L? . .
	BEQ	PR24_UL	. . yes
	BRA	PR_E16	---->	wrong size
;
PR24_ZJ	DC.W	PR24_NB1-PR24_ZJ	B
	DC.W	PR24_NW1-PR24_ZJ	W
	DC.W	PR24_NL-PR24_ZJ	L
	DC.W	PR24_NL-PR24_ZJ	S
	DC.W	PR24_ND-PR24_ZJ	D or Q
	DC.W	PR24_NX-PR24_ZJ	X
;
; Simulate "!" if needed
;
PR24_1	CMPI.B	#11,D3
	BLT	GNUM	not size S, D, X, P or Q
	CMPI.B	#19,D3
	BEQ	GNUM	size Q
	CMPI.B	#"-",D0
	BEQ	PR24_3	'tis a number
	CMPI.B	#"+",D0
	BEQ	PR24_3	'tis a number (again)
	CMPI.B	#".",D0
	BEQ	PR24_4	number or label
	CMPI.B	#"0",D0
	BLT	GNUM	FP but not decimal no
	CMPI.B	#"9",D0
	BGT	GNUM	       "
PR24_2	MOVE.B	#"!",D0
	BRA	GNUM1	allow floating point input without "!"
PR24_3	CMPI.B	#"!",1(A1)
	BEQ	GNUM	'!' already there
	BRA.S	PR24_2
;
PR24_4	CMPI.B	#"0",1(A1)
	BLT	GNUM
	CMPI.B	#"9",1(A1)
	BGT	GNUM
	BRA	PR24_3
;
; EQ list
;
PR24_EQ	MOVE.L	D3,D5	keep size
	BSR	SDUM	set up dummy label
	BMI	PR_E8	----> (couldn't)
	EXG	D3,D5	D5=lab no:D3=size
	MOVE.L	D2,D1
	BCLR	#31,D1	clear sign
	MOVE.L	D1,VAL(A0)
	MOVE.W	#9,TYPE(A0)  set EQ list|N
	MOVE.W	D5,D2	set LABEL no in D2
	TST.B	REL_SWTCH(A6)
	BEQ	PR24_UL	not relocatable
	MOVE.W	#8,TYPE(A0)
PR24_UL	MOVEQ	#0,D5
	BSR	PR2_GSP
	MOVE.L	A5,(A0)+	set *
	MOVE.W	D2,(A0)+	set LABEL no
	MOVEQ	#0,D6
	TST.B	D3
	BNE.S	PR24_UL1	size not B
	MOVEQ	#1,D6	set 'w' = 1
PR24_UL1	MOVE.B	D6,(A0)+
	MOVE.B	D3,D7
	CMPI.B	#10,D7
	BGT	PR24_UL3	S, D, X or P
	ADDQ.B	#2,D7
	BTST	#31,D2
	BEQ.S	PR24_UL2
	BSET	#7,D7    minus
PR24_UL2	MOVE.B	D7,(A0)+
	EXT.W	D3	0 to 5
	LEA	PR24_ZJ,A0
	ADDA.W	(A0,D3.W*2),A0
	MOVE.B	SIZE(A6),D3
	EXT.W	D3	replace SIZE
	JMP	(A0)
;
PR24_UL3	CMPI.B	#19,D7
	BNE	PR24_UL4	not Q
	MOVE.B	#15,D7	(preserve D7.T if needed!)
PR24_UL4	ANDI.W	#7,D7
	MOVE.B	PR24_ZK(D7.W),D3	size of insert
	MOVE.B	PR24_ZL(D7.W),D7	type INS
	BRA	PR24_UL2
;
PR24_ZK	DC.B	0,0,0,3,4,5,5,4
PR24_ZL	DC.B	0,0,0,16,32,48,49,33
;
; String LABEL or FP no
;
PR24_STR	CMPI.B	#-2,D1
	BNE	PR24_LP	could be S, D, X, P or Q
	ADDQ.W	#1,D1
	BEQ	PR_E1	---->
	LEA	BUF(A6),A0
	MOVE.W	(A0)+,D4	length
	CMPI.W	#1,D3
	BLT.S	PR24_CB1
	BEQ.S	PR24_CW
	ADDQ.W	#3,D4
	LSR.W	#2,D4
	ADD.W	D4,D4 4(INT(D4+3)/4)
	BRA.S	PR24_L1
PR24_CW	ADDQ.W	#1,D4
	LSR.W	#1,D4
PR24_L1	ADD.W	D4,D4 2(INT(D4+1)/2)
PR24_L5	ADDA.W	D4,A5	advance PC
	LSR.W	#1,D4	count of WORDS
	BRA.S	PR24_L2
PR24_L3	MOVE.W	(A0)+,D5	 next word
	BSR	PUT_W
PR24_L2	DBF	D4,PR24_L3
	BRA	PR24_SE
PR24_L4	MOVE.B	(A0)+,D5
	BSR	PUT_B
PR24_CB	DBF	D4,PR24_L4
	BRA	PR24_SE
PR24_CB1	ADDA.W	D4,A5
	BRA.S	PR24_CB
;
PR24_LP	CMPI.B	#-4,D1
	BEQ	PR24_Q	quad word
	CMPI.B	#-3,D1
	BNE	PR_E1	----> not FP
	SUBI.W	#10,D3	S=1 D=2 X=3 P=4
	BEQ	PR_E1	----> wrong . .
	BMI	PR_E1	----> . . size
	LSL.W	#2,D3	  4   8  12  16
	MOVE.W	D3,D1	keep in D1
	LEA	BUF(A6),A0   -> FP no
	CMPI.B	#8,D1
	BGT.S	PR24_LP4	X or P
	BEQ.S	PR24_LP2	D
	BSR	FP_XS	S	uses D3
	LEA	8+BUF(A6),A0
PR24_LP1	MOVE.W	D1,D4	set count in D4
	MOVE.B	SIZE(A6),D3
	EXT.W	D3	replace SIZE
	BRA	PR24_L5
;
PR24_Q	CMPI.W	#19,D3
	BNE	PR_E1	----> wrong size
	MOVEQ	#8,D1	set count of 8 bytes
	BRA	PR24_LP2A
;
PR24_LP2	BSR	FP_XD	uses D3 & D4
PR24_LP2A LEA	4+BUF(A6),A0
	BRA.S	PR24_LP1
;
PR24_LP4	CMPI.B	#16,D1	P? . . .
	BNE	PR24_LP1	. . . no
	BSR	FP_XP
	MOVEQ	#12,D1	set length of 12 bytes
	BRA	PR24_LP1
;
; DATA, PCK, PWID, FILETYPE
;
; D5.W=DATA, PCK, PWID, FLTYP: D7.L=minimum value | maximum value (0 for DATA)
;
PR25	SUBQ.L	#2,A5
	BSR	GNUM
	SUBQ.L	#1,D1	must be a known number
	BNE	PR_E1 ---->
	TST.L	D7
	BEQ	PR25_1	DATA
	CMP.W	D7,D2
	BGT	PR_E1	---->
	SWAP	D7
	CMP.W	D7,D2
	BLT	PR_E1	---->
	CMPI.W	#FLTYP,D5
	BNE	PR25_2	not FILETYPE
	BSET	#8,D2	see that user choice will be made
PR25_2	MOVE.W	D2,(A6,D5.W)	set constant
	BRA	INST_ED1
PR25_1	MOVE.L	D2,(A6,D5.W)
	BRA	INST_ED1
	LEA	DATA(A6),A0
	MOVE.L	D2,(A0)	set DATA
	BRA	INST_ED1
;
; IN (D7.W = 1) & LIB (D7.W = 0)
;
;  If the filename starts with @ it is assembled as
;  for the DC instruction - else it is read as a string.
;
PR26	SUBQ.L	#2,A5
	CMPI.B	#"@",(A1)
	BNE.S	PR26_2
	BSR	PR26_D
	BRA.S	PR26_3
PR26_2	BSR	STRG
	BMI	PR26_E1	---->
	MOVEA.L	A2,A0
PR26_3	MOVEQ	#0,D3	OPEN_IN
	BSR	OPENFILE
	TST.W	D7
	BEQ	PR29	LIB
	TST.L	D0
	BNE	QER10	---->
PR26_1	MOVE.W	CH_NO(A6),D0
	ADDQ.W	#1,D0
	BMI	PR_E70	----> too many nested INs
	MOVE.W	D0,CH_NO(A6)
	PEA	CH_LST(A6)
	PEA	4(D0.W*4) length needed
	PEA	0	mark 'no relocation'
	BSR	GSP
	LEA	12(A7),A7
	MOVE.L	A0,([CH_LST,A6],D0.W*4)
	MOVE.L	A0,CH_IN(A6)
	BRA	INST_ED1
;
PR26_D	MOVEQ	#0,D5	prepare for length
	LEA	62+BUF(A6),A0	filename goes here
	ADDQ.L	#1,A1	step past @
	MOVE.B	(A1),D0	next char
PR26_D5	PEA	PR26_D2
	CMPI.B	#"'",D0
	BEQ.S	PR26_D1
	CMPI.B	#'"',D0
	BNE	GNUM	get LABEL
PR26_D1	MOVEQ	#"?",D0	force a string
	BRA	GNUM1
PR26_D2	ADDQ.L	#2,D1
	BNE	PR26_E2	---->
	LEA	BUF(A6),A2
	MOVE.W	(A2)+,D2	length of this bit
	ADD.W	D2,D5
	CMPI.W	#40,D5
	BGT	PR26_E2	----> too long
	BRA.S	PR26_D3
PR26_D4	MOVE.B	(A2)+,(A0)+
PR26_D3	DBF	D2,PR26_D4
	CMPI.B	#",",D0
	BNE	PR26_D6	name ended
	MOVE.B	(A1),D0	next character after ','
	BRA	PR26_D5	go for more
PR26_D6	LEA	60+BUF(A6),A0	-> filename
	MOVE.W	D5,(A0)	set length
	MOVEA.L	A0,A2	for QER10 in case of error
	RTS
;
PR26_E2	ADDQ.L	#4,A7	restore stack
PR26_E1	TST.W	D7
	BNE	QER6	----> IN
	BRA	PR_E27	----> LIB
;
; These instructions are ignored - with a warning
; EXPAND, NOEXPAND, GENIF, ENDGEN
; PAGE, PAGELEN, TTL, TITLE, OPT
;
PR27	SUBQ.L	#2,A5
	BSR	PR_W16
	BRA	INST_ED1
;
; EOR
;
PR28	CMPI.B	#'#',(A1)
	BNE	PR28_1	1st <ea> not immediste
	MOVE.W	#$0A00,D5 set up D5 for EORI
	MOVE.L	#$CE0277FF,D7	and D7
	BRA	PR8
;
PR28_1	LSL.W	#6,D1
	OR.W	D1,D5	size
	BSR	EA
	MOVEQ	#-1,D6	set no size test in PR12
	BRA	PR12_E
;
; LIB	(No longer a Program on its own - see PR26)
;
PR29	TST.L	D0
	BNE	PR_E27 ---->
	MOVE.L	A0,-(A7)	   keep CH_ID
	MOVEQ	#-1,D3
	MOVEQ	#64,D2
	LEA	LBUF(A6),A1
	MOVEQ	#FS_HEADR,D0
	TRAP	#3
	TST.L	D0
	BEQ.S	PR29_5
	MOVEA.L	(A7)+,A0
	BRA	PR_E27 ---->
PR29_5	MOVE.L	LBUF(A6),D1   length of file
	MOVEQ	#-1,D2
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1	get space for file
	TST.L	D0
	BNE	PR29_ER1 ---->
	MOVEA.L	A0,A3	keep address
	MOVEA.L	(A7)+,A0	   ch_id
	MOVEA.L	A3,A1
	MOVE.L	LBUF(A6),D2
	MOVEQ	#-1,D3
	MOVEQ	#FS_LOAD,D0
	TRAP	#3	put file to A1
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2	and close it
	MOVE.L	D2,D5	length -> D5
	ADDA.L	D5,A5	adjust PC
	BSR	FLUSH1
	BCLR	#0,D5	odd?
	BEQ.S	PR29_E	no
	MOVEQ	#1,D7	set D7 (D7=0 @ PR29)
PR29_E	MOVEQ	#-1,D3
	MOVEA.L	CH_OUT(A6),A0
	MOVEA.L	A3,A1
PR29_1	CMPI.L	#$7000,D5 wodge size
	BGT.S	PR29_2
	MOVE.L	D5,D2	remaining bytes
	BRA.S	PR29_3
PR29_2	MOVE.L	#$7000,D2
PR29_3	SUB.L	D2,D5
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3	send wodge
	TST.L	D5	end?
	BNE.S	PR29_1	no
	TST.L	D7	odd?
	BEQ.S	PR29_4	no
	MOVE.B	(A1),D5	last byte
	BSR	PUT_B
PR29_4	MOVEA.L	A3,A0
	MOVEQ	#MT_RECHP,D0
	TRAP	#1	release space
	BRA	INST_ED1
;
PR29_ER1	MOVEA.L	(A7)+,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	BRA	PR_E28 ---->
;
; MACRO (D7.W = 0) MACROP (D7.W = 35)
;
; A2 -> label info : D3.W = label no : D4.W = MARK(A6)
;
PR30	SUBQ.L	#2,A5	adjust PC
	TST.W	D4	(set to MARK)
	BEQ	PR_E4	----> no label
	TST.W	CHM_NO(A6)      inside a MACRO? ...
	BNE	PR_E72	----> ... yes
	CMPI.W	#1,D4
	BNE	PR30_10	existing label
	ORI.W	#3,TYPE(A2)	stop this info being used
PR30_10	BSR	GNL	A2 -> name
	MOVE.B	-(A2),D6
	CLR.B	(A2)	zero byte for word length
	BSR	NMAC_NO
	TST.L	D0
	BEQ	PR30_X	---->
	BSR	NNEW_MAC	sets A0 -> new inf
	MOVE.B	D6,(A2)	replace byte
	CMPI.W	#1,D4
	BNE	PR30_11	existing label
	MOVE.B	#32,2(A2) make an impossible name
PR30_11	MOVE.W	MAC_NO(A6),D0
	BMI	QER34	----> too many MACROs
	MOVE.W	D0,(A0)
	CLR.B	TYPE(A0)	to set 0 for max par no
	MOVEA.L	A0,A3	keep pointer
	MOVE.W	D0,D5	MACRO number
	MOVEQ	#8,D1	bytes needed for chain
	BSR	NN_LG2	A0 -> space
	BNE	QER4	---->
	LEA	P_MAC(A6),A1
	MOVE.W	D5,D0	replace macro number for PR30_FLE
	BRA	PR30_12
PR30_13	MOVEA.L	(A1),A1
PR30_12	DBF	D5,PR30_13
	MOVE.L	A0,(A1)	set link
	ADDQ.W	#1,MAC_NO(A6)   advance No
	MOVEQ	#IO_OPEN,D4
	MOVEQ	#3,D3
	BSR	PR30_FLE	A0 is 'P' file : A2 is TMn file
	BNE	QER16	---->
	MOVEM.L	A0/A2,-(A7)  keep CH_ID, & 'P' file
	BSR	PR30_LN	advance line_no, set it to D2.L
;			and put PC & section -> PC_LST
;			(A7) is 'P' file, 4(A7) is the MACRO file
PR30_AG	BSR	PR30_NXL	get next line
	BEQ	PR30_9
;
	MOVEQ	#1,D4
PR30_AG1	MOVEA.L	(A7)+,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	DBF	D4,PR30_AG1
	BRA	QER11	----> no ENDM
;
PR30_9	MOVEQ	#0,D5	mark no '\' (as yet)
	LEA	LBUF(A6),A1
	MOVE.B	(A1)+,D0
	CMPI.B	#32,D0
	BEQ.S	PR30_SP1
	CMPI.B	#9,D0
	BEQ.S	PR30_SP1
	MOVEM.L	D0,-(A7)
	BSR	CH_LET
	MOVEM.L	(A7)+,D0
	BEQ	PR30_GC
	CMPI.B	#'&',D0
	BEQ	PR30_GC	extension line of parameters
	CMPI.B	#'\',D0
	BEQ	PR30_GC	allow a line to start with a parameter
	BRA	PR30_E1	next line
;
PR30_SP1	CMPI.B	#32,(A1)+
	BEQ.S	PR30_SP1
	CMPI.B	#9,-1(A1)
	BEQ.S	PR30_SP1
	SUBQ.L	#1,A1
	MOVE.L	#'MDNE',D6
	BSR	PR30_S	is it 'ENDM'? . .
	BEQ	PR30_E3	. . yes
	MOVE.L	#'LCAM',D6
	BSR	PR30_S	is it 'MACL'? . .
	BNE	PR30_GC3	. . no
;
; Set position for MACLabels
;
	MOVEA.L	A0,A1	set A1 to end of MACL
	CMPI.B	#10,(A1)
	BNE	PR30_LA
	BSR	PR_W17
PR30_LA	CMPI.B	#32,(A1)+
	BEQ	PR30_LA
	CMPI.B	#9,-1(A1)
	BEQ	PR30_LA
	SUBQ.L	#1,A1
	BSR	ML_ST	get label padded with zeros
	BMI	PR30_LA2	warn of truncation
	CMPI.W	#30,(A2)
	BLE	PR30_LA1	OK
PR30_LA3	BSR	PR_W4	truncation warning
	MOVE.W	#30,(A2)
PR30_LA1	MOVEA.L	4(A7),A0
	MOVEQ	#0,D1
	MOVEQ	#-1,D3
	MOVEQ	#FS_POSRE,D0
	TRAP	#3
	MOVE.L	D1,32+BUF(A6)
	MOVEA.L	(A7),A0
	MOVEQ	#36,D2
	LEA	BUF(A6),A1
	PEA	PR30_E1
;
PR30_SS	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER9	---->
	RTS
;
PR30_LA2	LEA	BUF(A6),A2
	BRA	PR30_LA3
;
PR30_S	MOVEA.L	A1,A0	keep position
PR30_5	MOVE.B	(A0)+,D3
	CMP.B	D6,D3
	BEQ.S	PR30_6
	ADDI.B	#32,D6
	CMP.B	D6,D3
	BNE	PR30_S1	not found
PR30_6	LSR.L	#8,D6	next character
	BNE.S	PR30_5
	CMPI.B	#9,(A0)
	BEQ	PR30_S1
	CMPI.B	#10,(A0)
	BEQ	PR30_S1
	CMPI.B	#32,(A0)
PR30_S1	RTS
;
; 'ENDM' found
;
PR30_E3	TST.W	D7	35 -> set this as max pars
	BEQ	PR30_E4
	MOVE.B	D7,TYPE(A3)
PR30_E4	MOVEA.L	(A7)+,A0	'P' file
	MOVEQ	#4,D2
	MOVEQ	#-1,D3
	LEA	BUF(A6),A1
	MOVE.L	#-1,(A1)
	BSR	PR30_SS
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	MOVEA.L	(A7)+,A0	   retrieve CH_ID & restore stack
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	BRA	INST_ED1
;
PR30_E2	LEA	LBUF(A6),A1
	SUBA.L	D5,A1
	ADD.L	D5,D2	length of line
	MOVEA.L	4(A7),A0	 retrieve ID of TMn file
	MOVEQ	#-1,D3
	BSR	PR30_SS
PR30_E1	BSR	PR30_LN
	BRA	PR30_AG
;
PR30_X	MOVE.B	D6,(A2)	replace byte
	BRA	PR_E30	---->
;
PR30_NXL	BFEXTU	CH_IN(A6){1:31},D3
	MOVEA.L	D3,A0
	LEA	LBUF(A6),A1
	MOVE.W	#256,D2	buffer size
	MOVEQ	#-1,D3
	MOVEQ	#IO_FLINE,D0
	TRAP	#3
	TST.L	D0
	BEQ.S	PR30_3
	CMPI.B	#-10,D0	EOF?
	BNE	QER8	no ---->
	TST.W	D1	any bytes fetched?
	BEQ	PR30_8	no
	MOVE.B	#10,(A1)	put LF
PR30_3	LEA	LBUF(A6),A1
	MOVEA.L	CH_TMP(A6),A0
	MOVE.W	D1,D2	No of bytes
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER9	---->
	RTS
PR30_8	MOVEQ	#-1,D0
	RTS
;
PR30_LN	ADDQ.L	#1,LINE_NO(A6)
	BSR	ST_LNO
	MOVE.L	A5,([PC_TH,A6])
	MOVE.W	CRT_SEC(A6),([PC_TH,A6],4)
	RTS
;
; To mark in D5 whether "|" or "\" has been
;
PR30_GC	CMPI.B	#10,D0	ENTER?
	BEQ	PR30_E2	yes - end of line
	CMPI.B	#"|",D0
	BEQ	PR30_GC2
	CMPI.B	#'\',D0
	BNE	PR30_GC3	not special
	CMPI.B	#'@',(A1)
	BEQ	PR30_GC2
	MOVE.B	(A1),D0
	BSR	MAC_PAR	sets D0.B = -1,0 to 35
	TST.B	D0
	BMI	PR30_GC2
	CMP.B	TYPE(A3),D0
	BLE	PR30_GC2
	MOVE.B	D0,TYPE(A3)	set no of pars
PR30_GC2	MOVEQ	#1,D5	mark '\' or '|' been
PR30_GC3	MOVE.B	(A1)+,D0
	BRA.S	PR30_GC
;
; To open or delete a file
;
; on entry:-		on exit:-
;    D3 = type of open	A2 = ID of MACRO file
;    D0 = No  of MACRO	A0 = ID of MACLabel file 'P'
;    D4 = #IO_xxx
;
PR30_FLE	LEA	MAC_BUF(A6),A0
	LEA	TMP_NME(A6),A2
	MOVE.W	(A2)+,D1	length
	MOVE.W	D1,(A0)+
	BRA.S	PR30_F1
PR30_F2	MOVE.B	(A2)+,(A0)+
PR30_F1	DBF	D1,PR30_F2
	EXT.L	D0
	BSR	LTOD
	PEA	PR30_F3
PR30_F4	MOVEQ	#-1,D1
	MOVE.L	D4,D0
	LEA	MAC_BUF(A6),A0
	CMPI.W	#IO_OPEN,D0	OPEN? ...
	BEQ	OPENFILE		yes ...
	BRA	DELETEFILE
;
PR30_F3	MOVEA.L	A0,A2
	MOVE.W	MAC_BUF(A6),D0
	ADDQ.W	#1,MAC_BUF(A6)
	MOVE.B	#'P',2+MAC_BUF(A6,D0.W)
	BRA	PR30_F4
;
; any MACRO name
;
; at entry D1.W = MACRO No D5.B = max no of pars
;
PR31	EXT.W	D5
	MOVE.W	D5,D7
	MULU.W	#PAR_SZE+2,D5	par size + count(wd)
	CMPI.L	#60,D5
	BGE	PR31_2
	MOVEQ	#60,D5		set 60 minimum space
PR31_2	SWAP	D7
	MOVE.W	D5,D7		keep space in D7.top
	SWAP	D7
	ADD.L	G_LIMIT(A6),D5	space for operating
	CMPA.L	D5,A7
	BLT	PR_E71	---->
	ADDQ.W	#1,MAC_CT(A6)
	SUBQ.L	#2,A5	     adjust PC
	LEA	PR31_TB,A3
	JMP	(A3,D7.W*8)	LINK in correct space
PR31_1	MOVE.L	A6,-(A7)	keep pointer
	MOVEA.L	A6,A3	par pointer in A3
	MOVEA.L	(A6),A6	A6 -> DATA SPACE
	MOVEQ	#0,D3	no of parameters
	MOVE.W	D1,D5	keep macro number
	LEA	-6(A3),A3 keep space for count
	CMPI.B	#10,(A1)	any parameters? . .
	BEQ	PR31_F	. . no
PR31_P	CMP.W	D7,D3
	BGE	PR31_ER2 ---->	too many pars
PR31_P6	MOVEQ	#BUF_SIZE,D2
	SWAP	D7
	CMP.W	D7,D2
	BLT	PR31_P8
	MOVE.W	D7,D2		limit this parameter to D7.W bytes
PR31_P8	SWAP	D7
	BSR	MAC_STRG	get parameter
	BPL	PR31_P7
	CMPI.W	#-2,D2
	BNE	PR31_ER1	---->
;
; Now get a new line
;
	MOVE.W	D3,D6
	BSR	PR30_LN
	BSR	PR30_NXL
	BMI	PR31_ER1A ---->
	MOVE.W	D6,D3
	LEA	LBUF(A6),A1
	CMPI.B	#'&',(A1)+
	BNE	PR31_ER1	---->
PR31_P5	CMPI.B	#' ',(A1)+
	BEQ	PR31_P5
	CMPI.B	#9,-1(A1)
	BEQ	PR31_P5
	SUBQ.L	#1,A1
	BRA	PR31_P6
PR31_P7	MOVE.W	(A2)+,D4	count
	SWAP	D7
	SUB.W	D4,D7	reduce available space by . .
	SUBQ.W	#2,D7	. . parameter size + 2
	SWAP	D7
	MOVE.W	D4,-(A3)
	BRA	PR31_P3
PR31_P4	MOVE.B	(A2)+,-(A3)
PR31_P3	DBF	D4,PR31_P4
	ADDQ.W	#1,D3	   advance count
	CMPI.B	#',',D0	more?
	BEQ.S	PR31_P	yes
	CMPI.B	#10,D0
	BEQ.S	PR31_F
	CMPI.B	#32,D0
	BEQ.S	PR31_F
	CMPI.B	#9,D0
	BNE	PR31_ER3 ---->
PR31_F	MOVEA.L	(A7),A3	restore par. pointer
	MOVE.W	D3,-2(A3) enter count
	MOVE.W	CHM_NO(A6),D7
	PEA	CHM_LST(A6)
	PEA	8(D7.W*8) length needed
	PEA	0	mark 'no relocation'
	BSR	GSP
	LEA	12(A7),A7
	MOVE.W	D5,([CHM_LST,A6],D7.W*8)	     set mac no
	MOVE.W	MAC_CT(A6),([CHM_LST,A6],D7.W*8,2) set MAC_CT
	ADDQ.W	#1,CHM_NO(A6)	advance count of nested MACROs
	SUBQ.W	#1,D7
	BMI	PR31_F1	do OPEN
PR31_F2	CMP.W	([CHM_LST,A6],D7.W*8),D5    look for mac no
	DBEQ	D7,PR31_F2
	BNE	PR31_F1	no earlier mac no - so OPEN
	BSR	PR31_PL	A0 = 'P' file link
	LEA	4(A0),A0
	MOVE.L	A0,([A7],-6)	set pointer to 'P' info
	MOVE.W	D7,D0
	MOVEA.L	CH_LST(A6),A1	now get the ID
PR31_F3	MOVE.L	(A1)+,D1	next ID
	BPL	PR31_F3	not a MACRO
	DBF	D0,PR31_F3
	BCLR	#31,D1	clear MACRO marker
	MOVEA.L	D1,A0	set ID
;
; Now set the current position of the file in CHM_LST
; and reset the position to the start
;
	MOVEQ	#-1,D3
	MOVEQ	#0,D1
	MOVEQ	#FS_POSRE,D0
	TRAP	#3
	MOVE.L	D1,([CHM_LST,A6],D7.W*8,4)   file pos.
	SWAP	D1
	TST.W	D1
	BNE	PR31_ER4	 ---->	 file too big!!
	MOVEQ	#0,D1
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	BRA	PR31_F4
PR31_F1	MOVEQ	#0,D3	open_in
	MOVEQ	#IO_OPEN,D4
	MOVE.W	D5,D0	set macro number to D0.W
	BSR	PR30_FLE	A0 -> extra P file: A2 -> MACRO file
	MOVEQ	#64,D2	space for header
	MOVEQ	#-1,D3	timeout
	LEA	MAC_BUF(A6),A1
	MOVEQ	#FS_HEADR,D0
	TRAP	#3
	TST.L	D0
	BNE	QER2	---->
	MOVE.L	MAC_BUF(A6),D1	file length
	MOVEM.L	A0/A2,-(A7)
	ADDQ.L	#4,D1
	MOVEQ	#7,D0
	ADD.L	D0,D1
	NOT.L	D0
	AND.L	D0,D1	round to higher 8 bytes
	BSR	NN_LG2	get that space
	BNE	QER4	---->
	MOVE.L	D1,(A0)+	keep length in space
	MOVE.L	A0,([8,A7],-6)	keep pointer
	MOVEA.L	A0,A1
	MOVEA.L	(A7)+,A0
	MOVE.L	MAC_BUF(A6),D2	file length
	MOVEQ	#-1,D3	timeout
	MOVEQ	#FS_LOAD,D0
	TRAP	#3
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	MOVEA.L	(A7)+,A2
	BSR	PR31_PL
	MOVE.L	([A7],-6),4(A0)	put address in chain
	MOVEA.L	A2,A0
PR31_F4	ADDA.L	#$80000000,A0	mark MACRO
	BRA	PR26_1
;
; Sets the address of this MACRO's 'P' file link in A0
;
PR31_PL	MOVE.W	D5,D0		macro number
	MOVEA.L	P_MAC(A6),A0	start of chain
	BRA	PR31_PL1
PR31_PL2	MOVEA.L	(A0),A0		next link
PR31_PL1	DBF	D0,PR31_PL2
	RTS
;
PR31_ER1A MOVE.W	D6,D3	replace parameter count so far
PR31_ER1	MOVE.W	D1,-(A7)	ERROR 31
	MOVEQ	#31,D1
PR31_ERX	BSR	DO_ERR
	MOVE.W	(A7)+,D1
	BRA	PR31_F
PR31_ER2	MOVE.W	D1,-(A7)	ERROR 32
	MOVEQ	#32,D1
	BRA.S	PR31_ERX
PR31_ER3	MOVE.W	D1,-(A7)	ERROR 9
	MOVEQ	#9,D1
	BRA.S	PR31_ERX
PR31_ER4	MOVE.W	D1,-(A7)	ERROR 69
	MOVEQ	#69,D1
	BRA	PR31_ERX
;
PR31_TB	LK	35
;
; MOVEC
;
PR32	MOVEQ	#54,D1
	BSR	EA_GTR
	BMI	PR_E38 ---->
	CMPI.B	#",",D0
	BNE	PR_E19 ---->
	CMPI.B	#16,D1
	BLT.S	PR32_1	D0/A7 found
	SUBI.W	#20,D1
	BMI	PR_E38 ----> PC, ZPC, SR, CCR not allowed
	BNE.S	PR32_4	not USP
	MOVEQ	#12,D1
PR32_4	SUBI.W	#12,D1	codes are 0 to 21
	BSR	PUT_W
	LEA	MC_TAB,A0
	MOVE.W	(A0,D1.W*2),D5
	BSR	EA
	LSL.W	#8,D2
	LSL.W	#4,D2
PR32_2	CMPI.B	#32,D0
	BEQ.S	PR32_3
	CMPI.B	#9,D0
	BEQ.S	PR32_3
	CMPI.B	#10,D0
	BNE	PR_E9 ---->
PR32_3	OR.W	D2,D5
	ADDQ.L	#2,A5
	BRA	INST_END
;
PR32_1	ORI.W	#1,D5	set dr -> 1
	BSR	PUT_W
	MOVE.W	D1,D5
	LSL.W	#8,D5
	LSL.W	#4,D5
	BSR	STRG
	BMI	PR_E38 ---->
	MOVEQ	#21,D1
	LEA	CR_LIST,A0
	MOVE.L	A1,-(A7)
	MOVEA.L	A2,A1
	BSR	FIND
	MOVEA.L	(A7)+,A1
	BMI	PR_E38 ---->
	ADD.W	D1,D1
	LEA	MC_TAB,A0
	MOVE.W	(A0,D1.W),D2
	BRA.S	PR32_2
;
; MOVES
;
PR33	LSL.W	#6,D1
	OR.W	D1,D5	add SIZE
	MOVE.B	#1,F_EA(A6)	jump over [EXT]
	BSR	EA
	CMPI.B	#$10,D2
	BLT.S	PR33_1	D/A
	BSR	PUT_W
	MOVEQ	#0,D5
	MOVE.W	#$FFFC,D7 D/A only & put in D5
	BSR	EA
	LSL.W	#4,D5
PR33_2	LSL.W	#8,D5
	ADDQ.L	#2,A5
	BRA	INST_END
;
PR33_1	MOVE.W	D2,D6
	SWAP	D7
	ANDI.W	#$FFC0,D5 clear reg from D5
	MOVE.B	#1,F_EA(A6)	jump over [EXT]
	BSR	EA
	BSR	PUT_W
	MOVE.W	D6,D5
	LSL.W	#4,D5
	ADDQ.W	#8,D5	set dr
	BRA.S	PR33_2
;
; BFCHG, BFCLR, BFSET, BFTST
;
;  Group I BF... <ea>{o:w}
;
PR34	MOVEQ	#0,D4
PR34_4
	MOVE.B	#1,F_EA(A6)   set jump [EXT]
	MOVE.L	A5,D6	keep 'PC'
	BSR	EA	get <ea>
	CMPI.B	#"{",D0
	BNE	PR_E40	---->
	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVEQ	#0,D5
	CLR.B	F_EA(A6)	    clear jump [EXT]
	MOVE.B	#8,SIZE(A6)   1st # 0-31 -> 6-10
	SWAP	D7	allow only # & Dn
	EXG	D6,A5	replace 1st 'PC'
	BSR	PR34_5	get #, Dn or just num
	MOVE.W	D2,D3
	ANDI.W	#$38,D3	mode
	BNE.S	PR34_1
	ANDI.W	#7,D2	reg
	ADDI.W	#32,D2	mark 'reg'
	LSL.W	#6,D2
	OR.W	D2,D5
PR34_1	CMPI.B	#":",D0
	BNE.S	PR34_E	---->
	MOVE.B	#9,SIZE(A6)   2nd # 1-32 -> 0-5
	BSR	PR34_5	get #, Dn or num
	EXG	D6,A5	restore 'PC'
	MOVE.W	D2,D3
	ANDI.W	#$38,D3	mode
	BNE.S	PR34_2	not D
	ANDI.W	#7,D2
	ADDI.W	#32,D2	mark 'reg'
	OR.W	D2,D5
PR34_2	CMPI.B	#"}",D0
	BNE	PR_E41	---->
	TST.B	D4
	BEQ	INST_END	Group I
	BMI.S	PR36_1	Group III
	MOVE.B	(A1)+,D0
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	MOVE.W	#$7FFE,D7 set for Dn (not in)
	BSR	EA
PR34_3	LSL.W	#4,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BRA	INST_END
PR34_E	EXG	D6,A5	restore 'PC'
	BRA	PR_E39	---->
;
PR34_5	CMPI.B	#"#",(A1)
	BEQ	EA
	MOVEM.L	D0/A1,-(A7)
	MOVEQ	#7,D1
	BSR	EA_GTR	<0 if not a register
PR34_6	MOVEM.L	(A7)+,D0/A1
	BPL	EA	it was not a number
	MOVEQ	#"#",D0
	BRA	EA1
;
; BFEXTS, BFEXTU, BFFFO
;
; Group II  BF...  <ea>{o:w},Dn
;
PR35	MOVEQ	#1,D4
	BRA	PR34_4
;
; BFINS
;
; Group III  BF...	Dn,<ea>{o:w}
;
PR36	BSR	EA	only D allowed
	MOVE.W	D2,D4	keep d in D4.top
	SWAP	D4
	MOVE.W	#-1,D4
	BCLR	#11,D7	allow # as well
	SWAP	D7
	BRA	PR34_4
;
PR36_1	SWAP	D4
	MOVE.W	D4,D2
	BRA.S	PR34_3
;
; BKPT
;
PR37
	MOVE.B	#10,SIZE(A6)
	BRA	PR22_1
;
; CALLM
;
PR38
	CLR.B	SIZE(A6)	    set Byte size
	BSR	EA	get # of byte size
	MOVEQ	#-1,D6	set 'size' in D6 for PR12_D
	BRA	PR12_D
;
; CAS
;
PR39	ADD.W	D1,D1
	ADDQ.W	#2,D1
	LSL.W	#8,D1
	OR.W	D1,D5
	SWAP	D5
	CLR.W	D5
	BSR	EA	get 1st Dn (in)
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	BCLR	#15,D7
	BSR	EA	get 2nd Dn (not in)
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	ANDI.W	#7,D2
	LSL.W	#6,D2
	OR.W	D2,D5
	SWAP	D5
	SWAP	D7
	MOVE.B	#1,F_EA(A6)   set jump [EXT]
	BSR	EA
	ADDQ.L	#2,A5
	BSR	PUT_W
	SWAP	D5
	BRA	INST_END
;
; CAS2
;
PR40	TST.W	D1
	BEQ	PR_E16	---->
	ADD.W	D1,D1
	ADDQ.W	#2,D1
	LSL.W	#8,D1
	OR.W	D1,D5
	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVEQ	#0,D5
	BSR	EA
	CMPI.B	#":",D0
	BNE	PR_E39	---->
	SWAP	D5
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	BCLR	#15,D7
	SWAP	D5
	BSR	EA
	CMPI.B	#":",D0
	BNE	PR_E39	---->
	ANDI.W	#7,D2
	LSL.W	#6,D2
	OR.W	D2,D5
	SWAP	D5
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	MOVE.B	(A1)+,D0	next character
	CMPI.B	#"(",D0
	BNE	PR_E42	---->
	ANDI.W	#7,D2
	LSL.W	#6,D2
	OR.W	D2,D5
	SWAP	D5
	SWAP	D7
	BSR	EA
	CMPI.B	#")",D0
	BNE	PR_E43	---->
	MOVE.B	(A1)+,D0	next character
	CMPI.B	#":",D0
	BNE	PR_E39	---->
	MOVE.B	(A1)+,D0	yet another char!!
	CMPI.B	#"(",D0
	BNE	PR_E42	---->
	LSL.W	#4,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	SWAP	D5
	BSR	EA
	CMPI.B	#")",D0
	BNE	PR_E43	---->
	LSL.W	#4,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	SWAP	D5
	BSR	PUT_W
	ADDQ.L	#2,A5
	SWAP	D5
	BRA	INST_END
;
; CHK2
;
PR41	MOVEQ	#1,D6
PR41_1	ADD.W	D1,D1
	LSL.W	#8,D1
	OR.W	D1,D5
	BSET	#0,F_EA(A6)   set jump [EXT]
	BSR	EA	get <ea>
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	ADDQ.L	#2,A5
	BSR	PUT_W
	SWAP	D7
	BSR	EA
	ANDI.W	#$F,D2
	ADD.W	D2,D2
	ADD.W	D6,D2
	LSL.W	#3,D2
	LSL.W	#8,D2
	MOVE.W	D2,D5
	BRA	INST_END
;
; CMP2
;
PR42	MOVEQ	#0,D6
	BRA.S	PR41_1
;
; PACK, UNPK
;
PR43	BSR	EA
	BCLR	#5,D5
	BNE.S	PR43_1	-(An)
	MOVE.W	#$7FFE,D7  to get Dn
	BRA.S	PR43_2
PR43_1	MOVE.W	#$7FEF,D7  to get -(An)
	ORI.W	#8,D5	 set R/M = 1
PR43_2	CMPI.B	#",",D0
	BNE	PR_E19	---->
	BSR	EA
	ANDI.W	#7,D2
	ADD.W	D2,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	SWAP	D7
	BRA	PR68
;
; RTM (PR44) see PR68
;
; TRAPcc
;
PR45
	MOVE.B	D1,SIZE(A6)
	ADDQ.W	#1,D1
	BEQ.S	PR45_1	no size
	CMPI.W	#1,D1
	BEQ	PR_E16	---->
	OR.W	D1,D5
	BSR	EA
	BRA	INST_END
PR45_1	OR.W	#4,D5
	BRA	INST_END
;
; DIVS, MULS
;
PR46	BSET	#7,F_EA(A6)	prepare for signed test (#)
	MOVEQ	#8,D6
PR46_1	CMPI.B	#1,D1
	BEQ	PR11_F	old form
	BTST	#14,D5
	BEQ.S	PR46_6	DIV
	MOVE.W	#$4C00,D5
	BRA.S	PR46_4
PR46_6	MOVE.W	#$4C40,D5
PR46_4	ADDQ.L	#2,A5
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19	---->
	BSR	PUT_W
	SWAP	D7
	BSET	#15,D7	get Dn in
	MOVEQ	#0,D5
	BSR	EA
	CMPI.B	#":",D0
	BNE.S	PR46_2
	BTST	#31,D6
	BNE.S	PR46_5	DIV.L
	ADDQ.W	#4,D6
PR46_5	MOVE.W	#$7FFE,D7 get Dn (not in)
	BSR	EA
PR46_3	LSL.W	#4,D2
	ADD.W	D6,D2
	LSL.W	#8,D2
	OR.W	D2,D5
	BRA	INST_END
;
PR46_2	BTST	#31,D6
	BNE	PR_E39	---->
	BRA.S	PR46_3
;
; DIVU, MULU
;
PR47	MOVEQ	#0,D6
	BRA.S	PR46_1
;
; DIVSL
;
PR48	MOVEQ	#8,D6
PR48_1	BSET	#31,D6	mark DIV.L
	CMPI.B	#2,D1
	BNE	PR_E16	---->
	BRA.S	PR46_4
;
; DIVUL
;
PR49	MOVEQ	#0,D6
	BRA.S	PR48_1
;
; CHK
;
PR50	CMPI.B	#1,D1
	BEQ	PR11_C	W
	BCLR	#7,D5	set code for L
	BRA	PR11_C
;
; EXTB
;
PR51	CMPI.B	#2,D1
	BNE	PR_E16	---->
	BSR	EA
	BRA	INST_END
;
; END
;
PR53	SUBQ.L	#2,A5
	MOVE.L	CH_IN(A6),D3
	BCLR	#31,D3
	MOVEA.L	D3,A0
	MOVE.L	#$400000,D1
	MOVEQ	#-1,D3
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	BRA	INST_ED1
;
; FABS*, FNEG*, FSQRT*
;
; (* = These have the form 'Fr..' as well as 'F..')
;
PR54	MOVEQ	#0,D6	mark one FPr acceptable
PR54_7	MOVE.W	D1,D3	keep size ** PR91 enters here **
	MOVE.B	#$19,F_EA(A6)   '..11..1'
	BSR	EA
	BTST	#6,D2	FPr?
	BEQ	PR54_1	no - <ea>
	CMPI.B	#13,D3
	BNE	PR_E16	----> Wrong size
	BSR	PUT_W
	ADDQ.L	#2,A5
	SWAP	D7
	MOVE.W	D7,D5	set 2nd word
	MOVE.W	D2,D4
	ANDI.W	#7,D4	1st reg
PR54_5	LSL.W	#3,D4	space for next reg
	CMPI.B	#1,D6
	BEQ.S	PR54_4	1 address
	BGT	PR54_6	2 or 3 addresses
	BTST	#7,D4	Test R/M
	BEQ.S	PR54_2	= 0 - need not have FPr
PR54_6	CMPI.B	#",",D0	** (PR90 enters here) **
	BNE	PR_E19	----> comma expected
PR54_3	BSR	GET_FP	Set D1 = FP reg no (or -1)
	BMI	PR_E44	----> FPr expected
	SUBQ.B	#3,D6	if 3 addresses D6 -> 0
	BNE.S	PR54_10	not (no longer) 3rd address
	OR.W	D1,D5	set 3rd address
	CMPI.B	#":",D0
	BNE	PR_E39	---->
	BRA.S	PR54_3
;
PR54_10	ADD.W	D1,D4	set 2nd reg
PR54_4	LSL.W	#7,D4
	OR.W	D4,D5	set 2nd inst word
	BRA	INST_END
;
PR54_2	CMPI.B	#",",D0
	BEQ.S	PR54_3	get 2nd reg
PR54_9	ANDI.W	#7,D2	1st reg  (PR62 enters here)
	OR.W	D2,D4	set this as 2nd reg
	BRA	PR54_4
;
PR54_1	MOVE.B	D2,D4
	ANDI.B	#$78,D4
	BNE.S	PR54_8	Not D
	CMPI.B	#11,D3
	BGT	PR_E16	----> Wrong size
PR54_8	OR.B	D2,D5	set <ea>
	BSR	PUT_W
	ADDQ.L	#2,A5
	SWAP	D7
	MOVE.W	D7,D5
	MOVE.W	#$10,D4
	BSR	PR54_SZ
	BRA	PR54_5
;
PR54_SZ	LEA	SZ_CODE,A0
	CMPI.W	#10,D3
	BLT.S	PR54_SZ1	B, W or L
	SUBQ.W	#8,D3	set other sizes to 3 to 6
PR54_SZ1	MOVE.B	(A0,D3.W),D3
	OR.B	D3,D4
	RTS
;
SZ_CODE	DC.B	6,4,0,1,5,2,3  (B,W,L,S,D,X,P)
;
; FADD*, FCMP, FDIV*, FMUL*, FSGLDIV, FSGLMUL, FSUB*
;  (* These instructions have the form 'Fr' as well as 'F')
;
PR55	MOVEQ	#2,D6	mark 2 addresses
	BRA	PR54_7
;
; FNOP
;
PR56	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVEQ	#0,D5
	BRA	INST_END
;
; FSAVE, FRESTORE, PSAVE, PRESTORE
;
PR57	EQU	PR14_B
;
; FDBcc, PDBcc
;
PR58	BSR	EA	Get D and put it in
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	BSR	PUT_W		send 1st word
	ADDQ.L	#2,A5
	SWAP	D7
	MOVE.W	D7,D5
	MOVEQ	#1,D7	set WORD length
	BRA	PR2_E
;
; FTST
;
PR59	MOVEQ	#1,D6    mark 1 address
	BRA	PR54_7
;
; FScc, PScc
;
PR60	CLR.B	SIZE(A6)
PR60_1	BSET	#0,F_EA(A6)	entry of PFLUSHR
	BSR	EA
	BSR	PUT_W
	ADDQ.L	#2,A5
	SWAP	D7
	MOVE.W	D7,D5
	BRA	INST_END
;
; FTRAPcc, PTRAPcc	D7.W = 2nd inst word, D7.top = 7(4) EA
;
PR61	MOVE.B	D1,D3
	ADDQ.B	#1,D1
	BNE.S	PR61_1
	MOVEQ	#4,D1
PR61_1	OR.B	D1,D5
	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVE.W	D7,D5
	TST.B	D3
	BMI	INST_END
	SWAP	D7
	BSR	EA
	BRA	INST_END
;
; FMOVE, FSMOVE, FDMOVE
;
PR62	MOVE.W	D1,D3
	MOVE.L	A5,D6	keep PC in case of {k}
	MOVE.B	#$29,F_EA(A6)	'101001'
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	BTST	#6,D2
	BEQ	PR62_EA	<ea>
	BTST	#5,D2
	BEQ	PR62_FP	FPn
PR62_3	MOVE.W	D2,D4
	MOVE.W	FP_D7A,D7
	MOVE.B	#9,F_EA(A6)
	BSR	EA
	ANDI.B	#$38,D2
	CMPI.B	#8,D2
	BNE.S	PR62_2	not An
	CMPI.B	#$7F,D4
	BNE	PR_E45	----> FPIAR expected
PR62_2	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVEQ	#$28,D5	set dr = 1 (FPcr -> <ea>)
PR62_1	ANDI.W	#3,D4
	MOVEQ	#8,D2
	LSR.W	D4,D2
	OR.W	D2,D5
	LSL.W	#3,D5
	LSL.W	#7,D5
	BRA	INST_END
;
PR62_EA	OR.B	D2,D5	set <ea> in D5
	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVE.W	FP_D7B,D7
	MOVE.B	#$18,F_EA(A6)
	BSR	EA
	BTST	#5,D2
	BEQ.S	PR62_EA1	FPn
	CMPI.B	#$3C,D5
	BNE.S	PR62_EA5	not immediate data
	CMPI.B	#2,D3
	BEQ.S	PR62_EA3	length L - OK
	BRA	PR_E16	---->
PR62_EA5	MOVE.B	D5,D4
	ANDI.B	#$38,D4	mode
	CMPI.B	#8,D4
	BNE.S	PR62_EA3	not An
	CMPI.B	#$7F,D2
	BNE	PR_E45	----> FPIAR expected
PR62_EA3	MOVEQ	#$20,D5	dr = 0
	MOVE.W	D2,D4
	BRA	PR62_1
PR62_EA1	SWAP	D7
	MOVE.W	D7,D5
	MOVEQ	#$10,D4
PR62_EA2	BSR	PR54_SZ	set size
	LSL.W	#3,D4
	BTST	#6,D4
	BEQ	PR54_9	<ea> to FPn
	CMPI.B	#3,D3
	BNE	PR54_9	not P
	CMPI.B	#"{",D0
	BNE	PR_E40	---->
	MOVE.L	D2,-(A7)
	MOVE.B	#2,ER_EA(A6)	set to jump 4 bytes on EA error
	MOVE.B	#15,SIZE(A6)
	MOVE.W	#$77FE,D7 	allow only # and D
	SUBQ.L	#2,D6	adjust PC to start of instruction and ...
	EXG	D6,A5	... set it in case k = label
	BSR	PR34_5	(puts # if needed)
	MOVEA.L	D6,A5	replace A5
	MOVE.L	(A7)+,D6	1st FPn
	CMPI.B	#"}",D0
	BNE	PR_E41	---->
	EXG	D2,D6
	BTST	#3,D6	0=Dn 1=k
	BNE	PR54_9	sets FPn
	BSET	#5,D4	mark {Dn} in bit 12 of D5
	BFINS	D6,D5{25:3}         set dynamic Dn
	BRA	PR54_9
PR62_EA4	LSL.W	#3,D4
	BRA	PR54_9
;
FP_D7A	DC.W	$FE00	<ea> in
FP_D7B	DC.W	$0FFD	FPn or FPcr not in
FP_D7C	DC.W	$7E00	<ea> or FPn not in
;
PR62_FP	TST.B	D3
	BMI	PR_E16	----> must be SIZE
	MOVE.W	D2,D4
	ANDI.W	#7,D4	1st reg to D4
	MOVE.W	FP_D7C,D7
	MOVE.B	#$19,F_EA(A6)
	BSR	EA
	BTST	#6,D2	FPn?
	BNE	PR62_FP2	yes
	SWAP	D0
	MOVE.B	D2,D0	mode/reg
	ANDI.B	#$38,D0	mode
	BNE.S	PR62_FP3
	CMPI.B	#11,D3
	BGT	PR_E16	----> Wrong size (D L)
PR62_FP3	SWAP	D0
	OR.B	D2,D5	put <ea> in
	MOVE.W	D4,D2	replace 1st reg
	MOVEQ	#$18,D4	mark reg -> <ea>
PR62_FP2	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVEQ	#0,D5
	BTST	#3,D4
	BEQ	PR62_EA4	FP,FP
	BRA	PR62_EA2	FP,<ea>
;
; FMOVEM
;
PR63	MOVEQ	#0,D6	set zero markers for 2nd word
	CMPI.B	#13,D1	13=X : 2=L
	BNE	PR63_C	control registers
	MOVE.B	#%10111101,F_EA(A6)	'10111101' allow reg list
	MOVE.W	#$7010,D7 to get all but -(An) & control regs
	BSET	#12,D6	set 'not -(An)'
	BSR	EA
	BTST	#6,D2
	BNE	PR63_F1	FPn 1st
	BFEXTU	D2{26:6},D3
	CMPI.W	#$3C,D3	reg list? . .
	BEQ	PR63_H1	. . yes
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	MOVE.W	D2,D1
	ANDI.W	#$38,D1	mode
	BEQ	PR63_D	D
	OR.B	D2,D5	put <ea> in
	MOVE.W	PR63_D7A,D7
	MOVE.B	#%10111100,F_EA(A6)	'10111100' allow reg list
	BSR	EA
	BSR	PUT_W
	ADDQ.L	#2,A5
	SWAP	D7
	MOVE.W	D7,D5
	BTST	#6,D2
	BNE	PR63_F2	FPn 2nd
	BFEXTU	D2{26:6},D3
	CMPI.W	#$3C,D3	reg list? . .
	BEQ	PR63_H	. . yes
	BSET	#11,D6	marks Dn
	ANDI.W	#7,D2	reg no
	LSL.W	#4,D2
	OR.W	D2,D6
	BRA	PR63_L2
;
PR63_H1	BSET	#13,D6		mark reg -> <ea>
PR63_H	OR.W	([OBUF,A6],-2),D6	get reg list value
	SUBQ.L	#2,OBUF(A6)	restore OBUF . .
	SUBQ.L	#2,A5		. . and PC
	BRA	PR63_L5
;
PR63_D7A	DC.W	$7FFC	D & FPn
PR63_D7B	DC.W	$8E0B	most of <ea> in
;
PR63_F1	BSET	#13,D6	mark FP -> <ea>
PR63_F2	MOVE.W	D2,D1
	ANDI.W	#7,D1	reg no
	BSR	PR63_L1
	BMI	PR_E22	---->
PR63_L5	BTST	#13,D6
	BEQ.S	PR63_L2	2nd time
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
PR63_L4	MOVE.W	PR63_D7B,D7     to get <ea> in
	MOVE.B	#1,F_EA(A6)
	BSR	EA
	BSR	PUT_W
	ADDQ.L	#2,A5
	SWAP	D7
	MOVE.W	D7,D5
	ANDI.W	#$78,D2
	CMPI.W	#$20,D2
	BNE.S	PR63_L2	not -(An)
	BCLR	#12,D6	clear 'not -(An)' marker
PR63_L2	OR.W	D6,D5
	BFEXTU	D6{19:2},D4
	CMPI.B	#2,D4
	BNE	INST_END
	MOVEQ	#7,D0
	CLR.B	D5	clear for reversal
	BRA	PR7_REV1
;
PR63_L	BSR	GET_FP	gets D1 = 0-7 (or minus if wrong)
	BMI	PR63_LE1	----> error in reg list
PR63_L1	BSET	D1,D6
	MOVE.W	D1,D4
PR63_L3	CMPI.B	#"/",D0
	BEQ.S	PR63_L	go back for more
	CMPI.B	#"-",D0
	BNE	PR63_L6	end
PR63_RGE	MOVE.B	(A1)+,D0	next character
	SUBI.B	#"0",D0
	BLT	PR63_RGE1	not number
	CMPI.B	#7,D0
	BGT	PR63_RGE1	not number
	MOVE.B	D0,D1
	EXT.W	D1	reg no
	MOVE.B	(A1)+,D0	next character
	BRA	PR63_RGE2
;
PR63_RGE1	SUBQ.L	#1,A1	restore A1
	BSR	GET_FP	set D1 for FPn
	BMI	PR63_LE1	----> Wrong reg list
PR63_RGE2 CMP.W	D4,D1
	BGT	PR63_RGE3
	EXG	D1,D4
	SUBQ.W	#1,D1
	BRA.S	PR63_RGE4
PR63_RGE3 ADDQ.W	#1,D4
PR63_RGE4 BSET	D4,D6
	CMP.W	D4,D1
	BGT.S	PR63_RGE3
	CMPI.B	#"-",D0
	BEQ	PR63_LE1	----> can't have 2 '-'s in a row
	BRA	PR63_L3
;
PR63_L6	MOVE	#0,CCR	good exit
	RTS
;
PR63_LE	MOVE	#%1000,CCR	set N
PR63_LE1	RTS
;
PR63_D	BSET	#11,D6	mark D
	BSET	#13,D6	mark reg -> <ea>
	ANDI.W	#7,D2	reg no
	LSL.W	#4,D2
	OR.W	D2,D6
	BRA	PR63_L4
;
PR63_C	MOVE.B	#$2D,F_EA(A6)
	CLR.W	D7
	BSR	EA
	BTST	#6,D2
	BEQ.S	PR63_C1	<ea> now get FPcr list
	BSET	#13,D6	set FPcr -> <ea>
	BRA.S	PR63_C7
;
; <ea> 1st. If it was 7(4) allow up to two more
;
PR63_C1	CMPI.B	#$3C,D2	was it 7(4)? . .
	BEQ	PR63_IM	. . yes
PR63_C8	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	MOVE.B	#$D,F_EA(A6)
	MOVE.W	#$FFF,D7
	OR.B	D2,D5	put <ea> in
PR63_C2	BSR	EA
PR63_C7	ANDI.B	#3,D2
	NEG.B	D2
	ADDI.B	#13,D2
	BSET	D2,D6	set bit in reg list
	BNE	PR_E46	----> FPcr already set
	CMPI.B	#"/",D0
	BEQ.S	PR63_C2	go back for more
	BTST	#13,D6
	BEQ.S	PR63_C11	<ea> -> FPcr
	MOVE.B	#1,F_EA(A6)
	MOVE.W	FP_D7A,D7
	BSR	EA
;
; Now check Dn and An conditions
;
PR63_C6	MOVE.W	D6,D4
	ANDI.W	#$1C00,D4 isolate reg list
	BEQ	PR_E22	----> No regs!
	MOVE.B	D5,D3
	ANDI.B	#%111000,D3   mode
	BEQ.S	PR63_C3	Dn
	CMPI.B	#8,D3
	BEQ.S	PR63_C4	An
	BRA.S	PR63_C5
PR63_C3	CMPI.W	#$1000,D4
	BEQ.S	PR63_C5	only FPCR
	CMPI.W	#$800,D4
	BEQ.S	PR63_C5	only FPSR
PR63_C4	CMPI.W	#$400,D4
	BNE	PR_E22	----> not just FPIAR
PR63_C5	BSET	#15,D6
	BSR	PUT_W	put 1st word away
	ADDQ.L	#2,A5	advance PC
	MOVE.W	D6,D5	2nd word
	BRA	INST_END
;
PR63_IM	MOVEQ	#1,D3	count up to two more items
PR63_IM1	CMPI.B	#":",D0	another item? . .
	BNE	PR63_C8	. . no
	MOVEQ	#"#",D0	set up for 7(4)
	BSR	EA1	get next item
	DBF	D3,PR63_IM1
	BRA	PR63_C8
;
PR63_C11	BFEXTU	D5{26:6},D0
	CMPI.B	#$3C,D0	7(4)? . .
	BNE	PR63_C6	. . no
;
; check that the number of FPcr's is right
;
	BFEXTU	D6{19:3},D0         reg bits
	MOVEQ	#2,D4		count
PR63_C9	TST.B	D0		ended? . .
	BEQ	PR63_C10		. . yes
	LSR.B	#1,D0
	BCC	PR63_C9		no bit here
	DBF	D4,PR63_C9	count bits
PR63_C10	CMP.W	D3,D4		correct number? . .
	BNE	PR_E73	---->	. . no
	BRA	PR63_C6
;
; PLPAR, PLPAW, PFLUSH, PTESTR, PTESTW
;
PR64	BSR	EA
	ANDI.B	#7,D2
	OR.B	D2,D5	put in reg
	BRA	INST_END
;
; ALIGN4
;
PR65	MOVEQ	#2,D4
	BRA.S	PR67_1
;
; ALIGN8
;
PR66	MOVEQ	#6,D4
	BRA.S	PR67_1
;
; ALIGN16
;
PR67	MOVEQ	#14,D4
PR67_1	MOVEQ	#0,D6	(offset = 0)
	SUBQ.L	#2,A5	reset PC
PR67_2	MOVE.B	D4,D0
	ORI.B	#16,D0	variable insert
	LSL.B	#3,D0
	MOVE.B	D4,D3
	LSR.B	#1,D3	(alignment no)/2
	OR.B	D3,D0	INS 1st byte
	BSR	PR2_GSP
	MOVE.L	A5,(A0)+	PC
	OR.B	D0,-4(A0) set var & adj's
	SUBQ.L	#1,D6
	MOVE.W	D6,(A0)+ set LABEL to -1-offset
	CLR.W	(A0)+	set w & type = 0
	BRA	PR23_1	put the space to BIN
;
; RTD, STOP
;
PR68	MOVE.B	#1,SIZE(A6) LPSTOP enters here
PR44	BSR	EA	  *** RTM ***
	BRA	INST_END
;
; TBLS
;
PR69	MOVE.W	#$0900,D3 2nd word (assuming <ea>)
	BRA.S	PR72_2
;
; TBLSN
;
PR70	MOVE.W	#$0D00,D3
	BRA.S	PR72_2
;
; TBLU
;
PR71	MOVE.W	#$0100,D3
	BRA.S	PR72_2
;
; TBLUN
;
PR72	MOVE.W	#$0500,D3
PR72_2	MOVE.W	D1,D4	keep size
	BSET	#0,F_EA(A6)
	BSR	EA
	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVE.W	D3,D5
	SWAP	D7
	ANDI.B	#$28,D2
	BNE.S	PR72_1	<ea>
	BCLR	#8,D5	mark Dym:Dyn
	CMPI.B	#":",D0
	BNE	PR_E39	----> ":" expected
	BSR	EA	get Dyn in
PR72_1	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	BCLR	#15,D7
	BSR	EA
	LSL.W	#6,D2
	OR.W	D2,D4
	BRA	PR8_1	set reg & size then exit
;
; CINVA, CPUSHA
;
PR73	MOVEQ	#1,D4	mark 'no <ea>'
	BRA.S	PR74_1
;
; CINVP, CINVL, CPUSHP, CPUSHL
;
PR74	MOVEQ	#0,D4	mark '<ea>'
PR74_1	BSR	STRG
	BMI	PR_E38	---->
	TST.L	D4
	BNE.S	PR74_2	no <ea>
	CMPI.B	#",",D0
	BNE	PR_E19	---->
PR74_2	MOVEQ	#3,D1	count - 1
	LEA	NC_LIST,A0
	MOVE.L	A1,-(A7)	keep pointer to input string
	MOVEA.L	A2,A1
	BSR	FIND
	MOVEA.L	(A7)+,A1	restore pointer
	BMI	PR_E38	---->
	LSL.W	#6,D1
	OR.W	D1,D5
	TST.L	D4
	BNE	INST_END	no <ea>
	BRA	PR64	get <ea>
;
; MOVE16
;
PR75	BSR	EA	get 1st item
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	MOVE.B	D2,D4
	ANDI.B	#56,D4	keep mode*8
	CMPI.B	#24,D4
	BEQ	PR75_2	(An)+
	BMI	PR75_1	(An)
;
; xxx.L
;
	MOVE.W	PR75_MA,D7   to get (An) or (An)+
	BSR	EA
	MOVE.B	D2,D4
	ANDI.B	#24,D4	mode*8
	ANDI.B	#7,D2
	OR.B	D2,D5	reg
	ADD.B	D4,D4
	SUBI.B	#56,D4
	NEG.B	D4	8*(7 - 2*mode)
	OR.B	D4,D5
	BRA	INST_END
;
PR75_1	OR.B	D2,D5
	MOVE.W	PR75_MB,D7   to get xxx.L
	BSR	EA
	BRA	INST_END
;
PR75_2	ANDI.B	#7,D2	reg
	OR.B	D2,D5
	SWAP	D7	to get xxx.L or (An)+
	BSR	EA
	BTST	#5,D2
	BNE	INST_END
	BSET	#5,D5
	BSR	PUT_W	send 1st word away
	ADDQ.L	#2,A5	step PC
	LSL.W	#4,D2
	LSL.W	#8,D2
	MOVE.W	D2,D5	second word in D5
	BRA	INST_END
;
PR75_MA	DC.W	$7FF3
PR75_MB	DC.W	$7EFF
;
; LPSTOP	(D7 1st word = 2nd word to be sent: 2nd word = <ea> template
;
PR76	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVE.W	D7,D5
	SWAP	D7
	BRA	PR68
;
; FBcc, PBcc
;
PR77	CMPI.W	#2,D1
	BNE.S	PR77_1	not L
	BSET	#6,D5
PR77_1	TST.W	D1
	BPL	PR2
	MOVEQ	#3,D1
	BRA	PR2
;
; CNOP
;
PR78	SUBQ.L	#2,A5	reset PC
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	PR_E1	---->
	MOVE.L	D2,D6	offset
	CMPI.B	#",",D0
	BNE	PR_E19	----> comma expected
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	PR_E1	---->
	CMPI.W	#4,D2	alignment no
	BEQ.S	PR78_1
	CMPI.W	#8,D2
	BEQ.S	PR78_1
	CMPI.W	#16,D2
	BNE	PR_E1	---->
PR78_1	CMP.L	D2,D6
	BGE	PR_E1	----> offset must be less than alignment
	BTST	#0,D6
	BNE	PR_E1	----> offset must be even
	NEG.L	D6	-offset
	MOVE.L	D2,D4
	SUBQ.L	#2,D4	alignment no - 2
	BRA	PR67_2
;
; IF (D7 = -1 {set by TEMPLATE}), IFcc (D7 = -2), IFC,IFNC (D7 = -3)
;   For IFcc, IFC, IFNC D5.W = conditions 0 to 5
;
; There is one IF_ON indicator for each level of IF
;  value	meaning
;   -1	no IF
;    0	IF level started - status OFF
;    1	status ON
;   -2	ELSE has occurred (no further ELSE's or ELSEIF's allowed)
;   -3	status is OFF but has been ON for this IF
;
PR79	SUBQ.L	#2,A5	reset PC
	ADDQ.W	#1,IF_L(A6)  increase IF level by 1
	BMI	PR_E51	----> too many nested IF's
	MOVE.W	IF_L(A6),D3
	PEA	IF_ON(A6)
	PEA	1(D3.W)		space needed
	PEA	-1 set new area to -1 and don't relocate
	BSR	GSP		get space
	LEA	12(A7),A7
	CLR.B	([IF_ON,A6],D3.W)	set off IF_ON
	TST.B	IF_SW(A6)
	BEQ	INST_ED1	already OFF - ignore
	ADDQ.W	#1,ACT_L(A6)	add one to acting level
	MOVE.L	LINE_NO(A6),IF_LNO(A6)	set IF_LNO for AND/OR_IF
	CLR.B	TEMP_ON(A6)
	BRA.S	PR79_7
;
; Entry point for AND_IF, OR_IF and ELSE_IF
;
PR79_6	TST.B	TEMP_ON(A6)
	BNE	INST_ED1
PR79_7	MOVEQ	#8,D1
	BSET	D1,D1	264
	BSR	NN_LG2	get 264 bytes
	BNE	QER4	---->
	MOVE.L	A0,-(A7)	set pointer to stack
;
; from here the stack needs adjusting on return
;
	CMPI.B	#-2,D7
	BEQ	PR79_CA	IFcc
	BLT	PR79_CB	IFC/IFNC
	BSR	PR79_CD	get COND in D5 (0 to 5)
	BSR	GNUM
	MOVE.L	D2,D6	keep value of 1st expression . .
	MOVE.W	D1,D4	. . and its type
	BMI	PR79_FS	String or FP
	BEQ	PR79_E24	----> label undefined
	CMPI.B	#4,D1
	BEQ	PR79_E24	---->
PR79_2	CMPI.B	#32,D0
	BEQ.S	PR79_1
	CMPI.B	#9,D0
	BNE	PR79_E52	---->faulty operator
PR79_1	CMPI.B	#32,(A1)+
	BEQ.S	PR79_1	go past spaces . .
	CMPI.B	#9,-1(A1) . . or TABS
	BEQ	PR79_1
	LEA	-1(A1),A1 reset A1
	CMPA.L	A3,A1
	BLT	PR79_E52	----> faulty operator
	BSR	GNUM
PR79_4	CMP.W	D1,D4
	BNE	PR79_E53	----> different types of exp.
	CMPI.B	#1,D1
	BEQ	PR79_N	type N
	BGT	PR79_PC	type PC
	CMPI.B	#1,D5	(only 1 & 4 allowed)
	BEQ	PR79_FS1	string or FP
	CMPI.B	#4,D5
	BNE	PR79_E54	----> wrong op. for string or FP
PR79_FS1	LEA	BUF(A6),A2
	MOVEA.L	(A7),A4	pointer to temp buffer
	ADDQ.W	#6,D1
	LEA	PR79_T2,A0
	ADDA.W	(A0,D1.W*2),A0
	JMP	(A0)
;
PR79_T2	DC.W	PR79_N-PR79_T2	reg list
	DC.W	PR79_N-PR79_T2	reg
	DC.W	PR79_Q2-PR79_T2	Quad
	DC.W	PR79_FS6-PR79_T2	FP
	DC.W	PR79_FS2-PR79_T2	string
;
; Quad (2nd operand)
;
PR79_Q2	MOVEQ	#1,D2
	LEA	4(A2),A2
	BRA	PR79_FS3
;
; FP (2nd operand)
;
PR79_FS6	MOVEQ	#2,D2	count
PR79_FS3	CMPM.L	(A2)+,(A4)+
	DBNE	D2,PR79_FS3
	BRA.S	PR79_3
;
; string (2nd operand)
;
PR79_FS2	MOVE.W	(A2)+,D2	count
	CMP.W	(A4)+,D2
	BRA.S	PR79_FS4
PR79_FS5	CMPM.B	(A2)+,(A4)+
PR79_FS4	DBNE	D2,PR79_FS5
PR79_3	MOVE	CCR,D4
	ADDQ.W	#1,D7	0=1F & ELSEIF 1=AND_IF 2=OR_IF
	ADD.W	D7,D7
	ADD.W	D7,D5
	ADD.W	D7,D7
	ADD.W	D7,D5	(6*D7 + D5)
	MOVEA.L	(A7)+,A0
	BSR	PR79_EE
;
; Stack no longer needs adjusting
;
	LEA	PR79_TL,A2
	ADDA.W	(A2,D5.W*2),A2
	MOVE	D4,CCR
	JMP	(A2)
;
PR79_EE	MOVEQ	#8,D1	return 264 bytes to heap
	BSET	D1,D1	264
	LEA	HEAPAD(A6),A1
	MOVEA.W	MM_LNKFR,A2
	JMP	(A2)
;
PR79_FS	MOVEA.L	(A7),A4
	ADDQ.L	#6,D1
	BMI	PR79_E1	---->
	CMPI.W	#5,D1
	BGE	PR79_E1	----> (just in case!)
	LEA	BUF(A6),A2
	LEA	PR79_T1,A0
	ADDA.W	(A0,D1.W*2),A0
	JMP	(A0)
;
PR79_T1	DC.W	PR79_2-PR79_T1	reg list
	DC.W	PR79_2-PR79_T1	reg
	DC.W	PR79_Q1-PR79_T1	Quad
	DC.W	PR79_F2-PR79_T1	FP
	DC.W	PR79_S-PR79_T1	string
;
; FP (1st operand)
;
PR79_F2	MOVEQ	#2,D2	count
PR79_F1	MOVE.L	(A2)+,(A4)+
	DBF	D2,PR79_F1
	BRA	PR79_2
;
; Quad (1st operand)
;
PR79_Q1	MOVEQ	#1,D2
	LEA	4(A2),A2
	BRA	PR79_F1
;
; string (1st operand)
;
PR79_S	MOVE.W	(A2)+,D2
	MOVE.W	D2,(A4)+
	BRA.S	PR79_S1
;
PR79_S2	MOVE.B	(A2)+,(A4)+
PR79_S1	DBF	D2,PR79_S2
	CMPI.B	#-3,D7
	BEQ	PR79_CB1	IFC/IFNC
	BRA	PR79_2
;
PR79_PC	MOVE.W	D2,D1
	BSR	LNPTR	set A0 -> LINN
	MOVE.L	VAL(A0),D2
	MOVE.W	D6,D1
	MOVE.W	(A0),D6	keep 1st SECTION
	BSR	LNPTR
	CMP.W	(A0),D6
	BEQ	PR79_PC1
	BSR	PR_W11	send warning
PR79_PC1	MOVE.L	VAL(A0),D6
PR79_N	CMP.L	D2,D6
	BRA	PR79_3
;
PR79_CA	MOVEQ	#-1,D7	reset D7 for 'IF'
	BSR	GNUM
	CMPI.W	#1,D1	N? . .
	BNE	PR79_E53	. . no ---->
	MOVE.L	D2,D6	keep value
	MOVEQ	#0,D2	second value
	MOVE.W	D1,D4	same type
	BRA	PR79_N
;
PR79_CB	BSR	BSUM
	CMPI.B	#-2,D1
	BNE	PR79_E53	---->
	CMPI.B	#',',D0
	BNE	PR79_E19	---->
	MOVE.W	D1,D4
	BRA	PR79_FS	put string to A4
PR79_CB1	MOVEQ	#-1,D7	reset D7
	PEA	PR79_4
BSUM	MOVE.B	#'?',D0	force string
	CMPI.B	#"'",(A1)
	BEQ	GNUM1
	CMPI.B	#'"',(A1)
	BEQ	GNUM1
	BRA	GNUM
;
; Get the operator to D5.W  and leave A3 -> char after the 1st of CD
;	D5  means
;	0 -> <
;	1 -> =
;	2 -> >
;	3 -> <=
;	4 -> <>
;	5 -> >=
;
PR79_CD	MOVEA.L	A1,A3
PR79_CD3	MOVE.B	(A3)+,D5
	CMPI.B	#10,D5
	BEQ	PR79_E55A ----> No operator IF clause
	CMPI.B	#'<',D5
	BLT	PR79_CD3
	CMPI.B	#'>',D5
	BHI	PR79_CD3
	CMP.B	(A3),D5	repeated '<', '=' or '>'? . .
	BNE	PR79_CD4	. . no - true condition
	MOVE.L	A3,D0
	SUB.L	A1,D0	'true' length of item to '<' etc
	BRA	PR79_CD5
PR79_CD6	MOVE.B	(A1,D0.W),1(A1,D0.W)	close up
PR79_CD5	DBF	D0,PR79_CD6
	ADDQ.L	#1,A3	step over second '<', '=' or '>'
	ADDQ.L	#1,A1		"
	BRA	PR79_CD3
;
PR79_CD4	SUBI.B	#60,D5	0->'<' 1->'=' 2->'>'
	MOVE.B	#32,-1(A3) replace CD by SPACE for GNUM
	CMPI.B	#1,D5
	BEQ	PR79_CDE	=
	BGT.S	PR79_CD1	>
	CMPI.B	#">",(A3)
	BNE.S	PR79_CD1	not <>
	ADDQ.B	#4,D5	<> -> 4
	BRA.S	PR79_CD2
PR79_CD1	CMPI.B	#"=",(A3)
	BNE.S	PR79_CDE
	ADDQ.B	#3,D5	<= -> 3 ->= -> 5
PR79_CD2	MOVE.B	#32,(A3)
PR79_CDE	RTS
;
PR79_E52	MOVEQ	#52,D1
PR79_ER	MOVE.L	D1,D6
	MOVEA.L	(A7)+,A0
	BSR	PR79_EE	return space to heap
	MOVE.L	D6,D1
	BRA	PR_EXX
;
PR79_E24	MOVEQ	#24,D1
	BRA	PR79_ER
PR79_E53	MOVEQ	#53,D1
	BRA.S	PR79_ER
PR79_E54	MOVEQ	#54,D1
	BRA.S	PR79_ER
PR79_E55A ADDQ.L	#4,A7
	MOVEQ	#55,D1
	BRA.S	PR79_ER
PR79_E1	MOVEQ	#1,D1
	BRA	PR79_ER
PR79_E19	MOVEQ	#19,D1
	BRA	PR79_ER
;
; IF & ELSEIF
;
PR79_TST	BLT.S	PR79_ON
	BRA.S	PR79_OFF
PR79_TST1 BEQ.S	PR79_ON
	BRA.S	PR79_OFF
PR79_TST2 BGT.S	PR79_ON
	BRA.S	PR79_OFF
PR79_TST3 BLE.S	PR79_ON
	BRA.S	PR79_OFF
PR79_TST4 BNE.S	PR79_ON
	BRA.S	PR79_OFF
PR79_TST5 BGE.S	PR79_ON
PR79_OFF	CLR.B	([IF_ON,A6],D3.W)
PR79_OFF1 CLR.B	IF_SW(A6)
	BRA	INST_ED1
PR79_ON	MOVE.B	#1,IF_SW(A6)
	MOVE.B	#1,([IF_ON,A6],D3.W)
	BRA	INST_ED1
;
; AND_IF
;
PR79_TSTA BLT	INST_ED1
	BRA	PR79_OFF
PR79_TSTA1	BEQ	INST_ED1
	BRA	PR79_OFF
PR79_TSTA2	BGT	INST_ED1
	BRA	PR79_OFF
PR79_TSTA3	BLE	INST_ED1
	BRA	PR79_OFF
PR79_TSTA4	BNE	INST_ED1
	BRA	PR79_OFF
PR79_TSTA5	BGE	INST_ED1
	BRA	PR79_OFF
;
; OR_IF
;
PR79_TSTO BLT	PR79_ON
	BRA	INST_ED1
PR79_TSTO1	BEQ	PR79_ON
	BRA	INST_ED1
PR79_TSTO2	BGT	PR79_ON
	BRA	INST_ED1
PR79_TSTO3	BLE	PR79_ON
	BRA	INST_ED1
PR79_TSTO4	BNE	PR79_ON
	BRA	INST_ED1
PR79_TSTO5	BGE	PR79_ON
	BRA	INST_ED1
;
PR79_TL	DC.W	PR79_TST-PR79_TL
	DC.W	PR79_TST1-PR79_TL
	DC.W	PR79_TST2-PR79_TL
	DC.W	PR79_TST3-PR79_TL
	DC.W	PR79_TST4-PR79_TL
	DC.W	PR79_TST5-PR79_TL
	DC.W	PR79_TSTA-PR79_TL
	DC.W	PR79_TSTA1-PR79_TL
	DC.W	PR79_TSTA2-PR79_TL
	DC.W	PR79_TSTA3-PR79_TL
	DC.W	PR79_TSTA4-PR79_TL
	DC.W	PR79_TSTA5-PR79_TL
	DC.W	PR79_TSTO-PR79_TL
	DC.W	PR79_TSTO1-PR79_TL
	DC.W	PR79_TSTO2-PR79_TL
	DC.W	PR79_TSTO3-PR79_TL
	DC.W	PR79_TSTO4-PR79_TL
	DC.W	PR79_TSTO5-PR79_TL
;
; AND_IF (D7 -> 0), OR_IF (D7 -> 1)
;
PR80	SUBQ.L	#2,A5	reset PC
	ADDQ.L	#1,IF_LNO(A6)	set to ignore this line
	MOVE.W	IF_L(A6),D3
	CMP.W	ACT_L(A6),D3
	BNE	INST_ED1	not active level
	MOVE.L	IF_LNO(A6),D1
	CMP.L	LINE_NO(A6),D1
	BNE	PR_E58	----> not close enough to IF
	BRA	PR79_6
;
; END_IF
;
PR81	SUBQ.L	#2,A5	reset PC
PR81_2	TST.L	IF_ON(A6)
	BEQ	PR_E56	----> no IFs yet
	MOVE.W	IF_L(A6),D3
	CMPI.B	#-1,([IF_ON,A6],D3.W)
	BEQ	PR_E56	----> no IF
	MOVE.B	#-1,([IF_ON,A6],D3.W)
	MOVE.L	#-1,IF_LNO(A6)
	CMP.W	ACT_L(A6),D3
	BNE.S	PR81_1
	SUBQ.W	#1,ACT_L(A6)	move down an active level
	MOVE.B	#1,IF_SW(A6)	switch ON
PR81_1	SUBQ.W	#1,IF_L(A6)	move down a level
	BRA	INST_ED1
;
; ELSE
;
PR82	SUBQ.L	#2,A5	reset PC
	TST.L	IF_ON(a6)
	BEQ	PR82_ER	----> no IFs yet
	MOVE.W	IF_L(A6),D3
	MOVE.B	([IF_ON,A6],D3.W),D1
	BMI	PR82_2
	MOVE.B	#-2,([IF_ON,A6],D3.W)  mark ELSE occurred
	CMP.W	ACT_L(A6),D3
	BNE	INST_ED1		not the active level
	TST.B	D1
	BNE.S	PR82_1		has been ON
	MOVE.B	#1,IF_SW(A6)	switch -> ON
	BRA	INST_ED1
PR82_1	CLR.B	IF_SW(A6) 	switch -> OFF
	BRA	INST_ED1
;
PR82_2	ADDQ.B	#3,D1	2=no IF,1=ELSE been,0=ignore (ON has occurred)
	BNE	PR82_ER
	MOVE.B	#-2,([IF_ON,A6],D3.W)	mark ELSE been
	BRA	INST_ED1
PR82_ER	SUBQ.B	#2,D1
	BEQ	PR_E56	----> no IF
	BRA	PR_E57	----> ELSE been
;
; ELSEIF	(D7 -> -1)
;
PR83	SUBQ.L	#2,A5
	TST.L	IF_ON(A6)
	BEQ	PR82_ER	----> no IFs yet
	MOVE.L	LINE_NO(A6),IF_LNO(A6)	set IF_LNO
	MOVE.W	IF_L(A6),D3
	MOVE.B	([IF_ON,A6],D3.W),D1
	BMI	PR83_1
	CMP.W	ACT_L(A6),D3
	BNE	INST_ED1	not ON
	MOVE.B	D1,TEMP_ON(A6)	set initial IF_ON
	BEQ	PR79_6	do condition
	MOVE.B	#-3,([IF_ON,A6],D3.W)	mark ON been
	BRA	PR79_OFF1  switch to OFF
;
PR83_1	ADDQ.B	#3,D1	2=no IF,1=ELSE been,0=ignore (ON has occurred)
	BEQ	INST_ED1
	BRA	PR82_ER
;
; SECTION (D7.W=0) COMMON (D7.W=1) ORG (D7.W=2)
;
PR84	SUBQ.L	#2,A5
	CMPI.W	#2,D7
	BNE	PR84_12	not ORG
	BSR	GNUM	get the PC address k
	SUBQ.W	#1,D1
	BNE	PR_E1	---->
	BFTST	D2{0:9}
	BNE	PR_E2	---->	PC too big
	MOVE.W	SEC_NO(A6),D0
	BSR	ORG_N	set 'ORG;n' name in BUF
	BRA	PR84_13
PR84_12	BSR	STRG
	BMI	PR_E1	---->
PR84_13	TST.B	REL_SWTCH(A6)
	BNE	PR84_1	SECTION been
	LEA	4+O_BUF(A6),A0
	CMPA.L	O_BUF(A6),A0	should be empty
	BNE	PR_E60	---->
	TST.L	BIN_OUT(A6)
	BNE	PR_E60	---->	should be empty
	MOVE.B	DEFAULT(A6),REL_SWTCH(A6)    mark linkable o/put
	LEA	BIN_NME(A6),A1
	LEA	O_BUF+4(A6),A0
	MOVE.W	(A1)+,D0	length of _BIN
	MOVE.W	D0,(A0)+
	SUBQ.W	#4,D0	length to move
	BRA.S	PR84_2	do this in case D0=0
PR84_3	MOVE.B	(A1)+,(A0)+
PR84_2	DBF	D0,PR84_3
	BTST	#3,REL_SWTCH(A6)	_o file?	. .
	BNE	PR84_10		. . no
	MOVE.W	#"_o",(A0)	set trailer . .
	SUBQ.W	#2,O_BUF+4(A6)	. . and length
	BRA	PR84_9
PR84_10	MOVE.L	#'_REL',(A0)	set trailer
PR84_9	LEA	O_BUF+4(A6),A0	reset A0
	MOVE.L	A5,-(A7)
	LEA	REL_NME(A6),A5
	BSR	SAVE_NM3
	MOVEA.L	(A7)+,A5
	LEA	O_BUF+4(A6),A0
	MOVEQ	#-1,D1	this job
	MOVEQ	#3,D3	open over
	BSR	OPENFILE
	BNE	QER26	----> can't open _o
	MOVE.L	A0,CH_OUT1(A6)
PR84_1	CMPI.W	#32,(A2)	length of SECTION name
	BLE.S	PR84_4	OK
	BSR	PR_W3	----> set warning
	MOVE.W	#32,(A2)
PR84_4	BSR	NSECT_NO	is it there? ...
	BEQ.S	PR84_5	... yes
	BSR	NNEW_SEC
	MOVE.W	SEC_NO(A6),D4
	CMPI.W	#MAX_SEC,D4
	BGE	PR_E65	---->
	MOVE.W	D4,(A0)
	MOVE.W	D7,TYPE(A0)	set COMMON/SECTION/ORG code
	ADDQ.W	#1,SEC_NO(A6)
	MOVE.B	D7,CO_SE(A6,D4.W)	            "
	BEQ	PR84_7	SECTION
	CMPI.W	#2,D7
	BNE	PR84_14		not ORG
	MOVE.L	D2,SEC_PC(A6,D4.W*4)	set PC=k
	MOVE.L	D2,VAL(A0)	set value of SECT info = k
	BSET	#7,REL_SWTCH(A6)	set ORG exists
	BRA	PR84_7
;
; For COMMON we set the NAME as a PC label at the COMMON start
;
PR84_14	BSR	NLAB_NO
	BNE	PR84_8		new label
	MOVE.W	TYPE(A0),D0
	BCLR	#12,D0		allow XDEF
	TST.W	D0
	BEQ	PR84_11		not used yet
	ORI.W	#3,TYPE(A0)	mark error
	BSR	PR_W15		issue a warning
	BRA	PR84_7
;
PR84_8	BSR	NNEW_LAB		info is zeroed
PR84_11	ORI.W	#6,TYPE(A0)	set PC type
	CLR.L	VAL(A0)
	MOVE.W	D4,(A0)		set COMMON number
	MOVE.W	D4,E_COM(A6)	store the highest 'COMMON'
	BRA	PR84_7
;
PR84_5	MOVE.W	(A0),D4	new no
	CMP.B	CO_SE(A6,D4.W),D7
	BEQ	PR84_7		no change
	BSR	PR_W9		Warning of COMMON/SECTION confusion
PR84_7	MOVE.W	CRT_SEC(A6),D0	current section no
	BMI.S	PR84_6	don't switch 1st time
	MOVE.L	A5,SEC_PC(A6,D0.W*4)        set current PC
PR84_6	MOVE.W	D4,CRT_SEC(A6)	set new no
	MOVEA.L	SEC_PC(A6,D4.W*4),A5        reset A5
	BRA	INST_ED1
;
; XDEF (D7.W = 5) & XREF (D7.W = 4)
;
PR85	MOVE.W	D1,D3	keep size (if any)
	SUBQ.W	#3,D1
	BNE	PR85_5
	MOVEQ	#-1,D3	set 'no size' to -1 (for XREF)
PR85_5	SUBQ.L	#2,A5
	TST.B	REL_SWTCH(A6)
	BEQ	PR_E61	----> no SECTION been
PR85_7	BSR	STRG
	BMI	PR_E1	---->
	MOVE.B	D0,D4	keep separator
	TST.W	(A2)
	BEQ	PR_E1	---->
	CMPI.W	#32,(A2)	length of LABEL
	BLE.S	PR85_6	OK
	BSR	PR_W3	---> warning
	MOVE.W	#32,(A2)
PR85_6	BSR	NLAB_NO
	BEQ	PR85_1	LABEL exists
	BSR	NNEW_LAB	 set up new entry
	BRA	PR85_10
PR85_1	BFTST	TYPE(A0){6:2}       reg or reg list? . .
	BNE	PR85_14		. . yes
	MOVE.W	D7,D1
	BTST	D1,TYPE(A0)
	BNE	PR85_2	----> E62
	CMPI.W	#5,D7	XDEF? . .
	BEQ	PR85_15	. . yes - allow SET
	BTST	#6,TYPE+1(A0)	SET? . . .
	BNE	PR85_9	----> E66 . . . yes
PR85_15	EORI.W	#1,D1	4 <--> 5
	BTST	D1,TYPE(A0)
	BNE	PR85_11	already done
	BFEXTU	TYPE(A0){14:2},D5
	CMPI.B	#3,D5
	BEQ	PR_E5	---->
PR85_10	CMPI.W	#4,D7
	BEQ.S	PR85_3	XREF
	BSET	#4,TYPE(A0)      mark XDEF
PR85_8	CMPI.B	#",",D4	more? . . .
	BEQ	PR85_7	. . . yes
	BRA	INST_ED1
PR85_3	MOVEQ	#0,D1	prepare for N
	MOVE.W	D3,D5	size
	BPL.S	PR85_4	N
	MOVEQ	#2,D5	set L
	MOVEQ	#1,D1	PC
PR85_4	BSET	D1,TYPE+1(A0)    mark type
	EORI.W	#1,D1	2 <--> 1
	BTST	D1,TYPE+1(A0)    try the other one
	BNE	PR_E62	---->
	ADD.W	D5,D5
	ADDQ.W	#1,D5
	BFINS	D5,TYPE(A0){0:3}
	MOVE.W	XREF_NO(A6),VAL+2(A0)	set <id>
	ADDQ.W	#1,XREF_NO(A6)
	BRA	PR85_8
;
PR85_11	CMPI.W	#5,D7
	BEQ	PR85_8	XDEF try next argument
	BFEXTU	TYPE(A0){0:2},D0    bits 14,15
	BFEXTU	TYPE+1(A0){6:2},D5  bits 0,1
	LSL.W	#2,D5
	ADD.W	D5,D0	bits 1,0,15,14
	MOVE.W	D3,D5	size
	BPL	PR85_12	0,1,2
	MOVEQ	#3,D5
PR85_12	LEA	PR85_BTS,A2
	CMP.B	(A2,D5.W),D0     same as before? . . .
	BNE	PR85_13	---->  . . . no
	BRA	PR85_8	next argument
;
PR85_BTS	DC.B	%0100,%0101,%0110,%1010
;
PR85_2	ORI.W	#3,TYPE(A0)      mark error
	BRA	PR_E62	---->
PR85_9	ORI.W	#3,TYPE(A0)
	BRA	PR_E66	---->
PR85_13	ORI.W	#3,TYPE(A0)
	BRA	PR_E64	---->
PR85_14	ORI.W	#3,TYPE(A0)
	BRA	PR_E5	---->
;
; With D5.W = 0 (to set REL_SWTCH)
; UND_ERR (D7.W=$8001) UND_XREF (D7.W=1)
; PC_REL (D7.W=$8002) NON_PC (D7.W=2)
; COM_DUM (D7.W=$8004) COM_ALL (D7.W=4)
;
;
; With D5.W = 1 (to set DEFAULT)
; O_FILE (D7.W=3) REL_FILE (D7.W=$8003)
;
PR86	SUBQ.L	#2,A5
	TST.W	D5
	BEQ	PR86_2
	TST.B	REL_SWTCH(A6)
	BNE	PR_E83	---->
	BRA	PR86_3
PR86_2	TST.B	REL_SWTCH(A6)
	BEQ	PR_E61	---->
PR86_3	TST.W	D5
	BEQ	PR86_4
	LEA	DEFAULT(A6),A0
	BRA	PR86_5
PR86_4	LEA	REL_SWTCH(A6),A0
PR86_5	TST.W	D7
	BMI	PR86_1	clear
	BSET	D7,(A0)	 set bit
	BRA	INST_ED1
PR86_1	BCLR	D7,(A0)	 clear bit
	BRA	INST_ED1
;
; CASE_DIFF (D7.W=0), CASE_IND (D7.W=$8000)
; LOW_EA (D7.W=4), HIGH_EA (D7.W=$8004)
; ERR (D7.W=5), LST (D7.W=$8005)
;
PR87	SUBQ.L	#2,A5
	TST.W	D7
	BMI	PR87_1	clear
	BSET	D7,DIP(A6)
	BRA	INST_ED1
PR87_1	BCLR	D7,DIP(A6)
	BRA	INST_ED1
;
; MODULE
;
PR88	SUBQ.L	#2,A5
	BSR	STRG
	BMI	PR_E1	---->
	CMPI.W	#32,(A2)
	BLE.S	PR88_1
	BSR	PR_W3	warning
	MOVE.W	#32,(A2)	set length
PR88_1	LEA	1(A2),A3
	BSR	SET_MNE1
	BRA	INST_ED1
;
; COMMENT
;
PR89	SUBQ.L	#2,A5	reset PC
	TST.B	REL_SWTCH(A6)
	BEQ	PR_E61	---->
	MOVE.B	#"?",D0	force string
	BSR	GNUM1
	ADDQ.L	#2,D1
	BNE	PR_E1	---->
	LEA	BUF(A6),A1
	CMPI.W	#80,(A1)
	BLE.S	PR89_1	<80 OK
	BSR	PR_W4
	MOVE.W	#80,(A1)	restrict length to 80
PR89_1	BSR	SDUM	set up dummy label
	BMI	PR_E11	---->
	MOVEA.L	A0,A2	A2 -> label INF
	BSR	PUT_STRG	set string to STR_LST
	BSR	PR2_GSP
	MOVE.L	A5,(A0)+	PC
	MOVE.W	D3,(A0)+	label no
	MOVE.W	#$FF,(A0)+ w=0:type INS = -1
	BRA	INST_ED1
;
; FMOVECR
;
; D7 = <ea> marker|second FP word
;
PR90	BSR	PUT_W
	ADDQ.L	#2,A5
	MOVE.W	D7,D5
	SWAP	D7
	MOVE.B	#15,SIZE(A6)
	BSR	EA	get #ccc -> D5
	MOVEQ	#0,D6
	MOVEQ	#0,D4
	BRA	PR54_6	get FPn in
;
; FSINCOS
;
PR91	MOVEQ	#3,D6
	BRA	PR54_7
;
; 68040, 68030, 68EC030, 68851 D7.W = 0, 1, 2, 3
;
PR92	SUBQ.L	#2,A5
	BFINS	D7,DIP(A6){4:3}
	BRA	INST_ED1
;
; PMOVE 69EC030
;
PR93	MOVEQ	#2,D1	count for regs
	MOVEQ	#1,D4	mark 68EC030
	LEA	MMU_R2,A0
PR93_S	MOVE.L	A1,D6	** entry point PR95, PR96 **
	MOVE.B	#1,F_EA(A6)	to leap 2nd word
	BSR	STRG
	BMI	PR_E1	---->
	EXG	A1,A2
	BSR	FIND
	BMI	PR93_1	MEM -> REG
	MOVEA.L	A2,A1	reset pointer
	BSET	#9,D5	set R/W = 1
PR93_2	TST.W	D4
	BMI	PR93_3	68851
	BNE	PR93_13	68EC030
	CMPI.W	#1,D1
	BEQ	PR_E1	---->
	CMPI.W	#3,D1
	BLE	PR93_6	OK
	CMPI.W	#9,D1
	BGT	PR93_6	OK
	BRA	PR_E1	---->
PR93_3	CMPI.W	#10,D1
	BLT	PR93_5	OK
	CMPI.W	#15,D1
	BLE	PR_E1	---->
	BRA	PR93_5
PR93_13	ADDI.W	#10,D1	68EC030
	BRA	PR93_7
PR93_6	MOVE.W	D1,D3	68030
	CMPI.W	#4,D1
	BLT	PR93_8
PR93_7	MOVEQ	#0,D3
	CMPI.W	#12,D1
	BNE	PR93_9
	BSET	#13,D5
PR93_8	BSET	#14,D5
	BRA	PR93_10
PR93_9	SUBQ.W	#8,D1
	MOVE.W	D1,D3
	BRA	PR93_10
PR93_5	MOVE.W	D1,D3	68851
	SUBQ.W	#8,D1
	BMI	PR93_10
	BSET	#13,D5
	MOVE.W	D1,D3
	SUBQ.W	#2,D1
	BMI	PR93_10
	SUBQ.W	#6,D1
	BFINS	D1,D5{27:3}
	MOVEQ	#4,D3
	BTST	#3,D1
	BEQ	PR93_10
	ADDQ.W	#1,D3
PR93_10	BFINS	D3,D5{19:3}
	TST.L	D4
	BMI	PR93_11	2nd time (MEM -> REG)
	CMPI.B	#",",D0
	BNE	PR_E19	----> no comma
	SWAP	D5
	MOVE.W	#$F000,D5 1st word
	SWAP	D7
	BSR	EA	get <ea> in
	ADDQ.L	#2,A5
	BSR	PUT_W	send 1st word
	SWAP	D5	to 2nd word
PR93_11	TST.W	D4
	BPL	INST_END	not 68851
	BFEXTU	D5{19:3},D1         C_REG
	BEQ	INST_END	OK
	CMPI.B	#3,D1
	BGT	INST_END	OK
	BFEXTU	D5{10:6},D1         mode|reg
	CMPI.B	#15,D1
	BGT	INST_END	OK
	BRA	PR_E18	---->
;
PR93_1	TST.W	D4
	BMI	PR93_Z
PR93_14	MOVEA.L	D6,A1	restore pointer
PR93_12	MOVEM.L	D1/A0,-(A7)
	MOVE.B	#4,ER_EA(A6) to correct stack if error in EA
	SWAP	D5
	MOVE.W	#$F000,D5 1st word
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19	----> no comma
	ADDQ.L	#2,A5
	BSR	PUT_W	1st word
	SWAP	D5
	MOVEM.L	(A7)+,D1/A0
	BSR	STRG
	BMI	PR_E1	---->
	EXG	A1,A2
	BSR	FIND
	BMI	PR_E38	---->
	BSET	#31,D4	mark 2nd time
	BRA	PR93_2
;
PR93_Z	CMPI.B	#"#",(A1) does immediate data follow? ...
	BNE	PR93_14	.. no
	MOVEA.L	A2,A1
	BSR	STRG	get reg string (after <ea>)
	BMI	PR_E1	---->
	MOVEQ	#31,D1	no of items
	MOVEA.L	A2,A1
	BSR	FIND
	BMI	PR_E1	---->
	MOVE.B	PM_SZ(D1.W),SIZE(A6)	set size
	BRA	PR93_14
;
PM_SZ	DC.B	2,19,19,19,0,0,0,1	TC,DRP,SRP,CRP,CAL,VAL,SCC,AC
	DC.B	1,1,1,1,1,1,1,1	  all others
	DC.B	1,1,1,1,1,1,1,1	     are
	DC.B	1,1,1,1,1,1,1,1	      W (19 = quad)
;
; PTESTR, PTESTW 68030
;
PR94	MOVEQ	#0,D3
PR94_5	MOVEQ	#10,D4	size
PR94_4	MOVE.L	A1,D6	keep pointer
	MOVE.B	#1,F_EA(A6)
	BSR	STRG
	BMI	PR_E1	---->
	EXG	A1,A2
	LEA	D_LIST,A0
	MOVEQ	#35,D1	look for Dn, SFC and DFC
	BSR	FIND1
	BMI	PR94_1	try for #
	MOVEA.L	A2,A1	replace updated pointer
	CMPI.W	#8,D1	is it Dn? . . .
	BLT	PR94_2	. . . yes
	SUBI.W	#33,D1	SFC=0 DFC=1 neg is error
	BMI	PR_E1	---->
PR94_3	OR.W	D1,D5	set FC
PR94_6	CMPI.B	#",",-1(A1)	entry from PR94_1 (# in)
	BNE	PR_E19	----> no comma
	TST.W	D3
	BMI	PR102_3	PLOADx
	BNE	PR99_1	PFLUSH
	SWAP	D5
	MOVE.W	#$F000,D5 1st word
	SWAP	D7
	MOVE.L	A5,D6	keep PC
	BSR	EA
	CMPI.B	#",",D0
	BNE	PR_E19	----> no comma
	ADDQ.L	#2,A5
	BSR	PUT_W	send 1st word
	SWAP	D5
	CLR.B	F_EA(A6)
	SWAP	D7
	EXG	D6,A5	retrieve old PC and keep new one
	MOVE.B	#16,SIZE(A6)
	BSR	EA
	MOVEA.L	D6,A5	retrieve 'new' PC
	CMPI.B	#",",D0
	BNE	INST_END	no An
	MOVE.W	#$7FFD,D7 only An
	BSR	EA
	BFINS	D2,D5{23:4}         put An in
	BRA	INST_END
;
PR94_1	BSET	#4,D5	mark immediate
	MOVEA.L	D6,A1	restore pointer
	MOVE.B	D4,SIZE(A6)
	PEA	PR94_6
PR94_7	CMPI.B	#"#",(A1)
	BEQ	EA
	MOVEQ	#"#",D0
	BRA	EA1
PR94_2	ORI.W	#8,D1	mark Dn in FC
	BRA	PR94_3
;
; PMOVE 68030
;
PR95	MOVEQ	#12,D1	count for reg
	MOVEQ	#0,D4	mark 68030
PR95_1	LEA	MMU_R1,A0 point to reg list
	BRA	PR93_S
;
; PMOVE	68851
;
PR96	MOVEQ	#31,D1	count for reg
	MOVE.L	#$FFFF,D4 (leave bit 31 = 0)
	BRA	PR95_1
;
; PMOVEFD
;
PR97	MOVEQ	#11,D1	count for reg
	MOVEQ	#0,D4	mark 68030
	LEA	MMU_R1,A0
	BRA	PR93_12
;
; PTESTR, PTESTW 68851
;
PR98	MOVEQ	#0,D3	for PTEST (not PFLUSH)
PR98_1	MOVEQ	#4,D4	size for FC
	BRA	PR94_4
;
; PFLUSH 68030
;
PR99	MOVEQ	#1,D3	mark PFLUSH
	BRA	PR94_5
;
PR99_1	CLR.B	F_EA(A6)
	CMPI.B	#4,D4
	BEQ	PR99_2	68851
	MOVE.B	#17,SIZE(A6)
	BRA.S	PR99_3
PR99_2	MOVE.B	#18,SIZE(A6)
PR99_3	PEA	PR99_6
	BRA	PR94_7	get MASK
PR99_6	SWAP	D5	to 1st word (entry of PFLUSHA)
	MOVE.W	#$F000,D5
	CMPI.B	#",",D0	<ea> to come? . . .
	BEQ	PR99_4	. . . yes
PR99_5	ADDQ.L	#2,A5
	BSR	PUT_W
	SWAP	D5
	BRA	INST_END
PR99_4	MOVE.B	#1,F_EA(A6)
	SWAP	D7
	BSR	EA
	BSET	#27,D5	set "<ea> there"
	BRA	PR99_5
;
; PFLUSH, PFLUSHS 68851
;
PR100	MOVEQ	#1,D3	mark PFLUSH
	BRA	PR98_1
;
; PFLUSHA 68030, 68EC030 and 68851
;
PR101	MOVEQ	#0,D0	set  "not  comma"
	BRA	PR99_6
;
; PVALID
;
PR102	MOVE.L	A1,D6
	BSR	STRG
	BMI	PR_E1	---->
	MOVEQ	#4,D4	count
	LEA	.VAL,A0
PR102_1	CMPM.B	(A2)+,(A0)+
	DBNE	D4,PR102_1
	BEQ	PR102_2	'VAL'
	MOVEA.L	D6,A1	retrieve pointer
	BSR	EA	get An in
	BCLR	#3,D5
	BSET	#10,D5
PR102_2	CMPI.B	#",",D0
	BNE	PR_E19	----> no comma
	MOVE.B	#1,F_EA(A6)
PR102_3	SWAP	D5
	MOVE.W	#$F000,D5 1st word
	SWAP	D7
	BSR	EA
	ADDQ.L	#2,A5
	BSR	PUT_W	1st word
	SWAP	D5
	BRA	INST_END
;
.VAL	DC.W	3,"VA","L "
;
; PLOADR, PLOADW 68030
;
PR103	MOVEQ	#-1,D3	mark PLOAD
	BRA	PR94_5	get FC
;
; PLOADR, PLOADW 68851
;
PR104	MOVEQ	#-1,D3	mark PLOAD
	BRA	PR98_1
;
; PFLUSHR
;
PR105	MOVE.B	#19,SIZE(A6)	set for quad word
	BRA	PR60_1
;
; RS_SET
;
PR106	SUBQ.L	#2,A5
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	PR_E1	---->
	MOVE.L	D2,RS(A6) reset the start point of RS
	BRA	INST_ED1
;
; ERROR (D7.W=0) WARNING (D7.W=1)
;
PR107	SUBQ.L	#2,A5
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	PR_E1	---->
	MOVE.L	D2,D1	only 1 to 3 allowed
	BMI	PR_E1	---->
	SUBQ.L	#4,D2
	BPL	PR_E1	---->
	TST.W	D7
	BEQ	PR107_1	'ERROR'
	NEG.W	D1	set D1.W negative for 'WARNING'
PR107_1	MOVE.W	6+PR107_T(D1.W*2),D1	get ER./WA. no.
	BSR	DO_ERR	set the message
	BRA	INST_ED1
;
PR107_T	DC.W	-14	'WARNING' 3
	DC.W	-13		2
	DC.W	-12		1
	DC.W	1	---->E1
	DC.W	77	'ERROR'	1
	DC.W	78		2
	DC.W	79		3
;
; GOTO (only inside MACROs)
;
PR108	SUBQ.L	#2,A5
	MOVE.L	CH_IN(A6),D7
	BPL	PR_E80
	BSR	ML_ST	get <label> padded with zeros to 32 bytes
	BMI	PR_E1	---->
	CMPI.W	#30,(A2)
	BLE	PR108_1	OK
	BSR	PR_W4	label truncated (to 30!)
PR108_1	MOVEA.L	([A7],-6),A0	pointer to area
PR108_2	TST.L	(A0)
	BMI	PR108_4		ended
	LEA	BUF(A6),A2
	MOVEQ	#7,D1	to count 8 long words
PR108_3	CMPM.L	(A2)+,(A0)+
	DBNE	D1,PR108_3
	BEQ	PR108_4	found
	LEA	4(A0,D1.W*4),A0	to next entry
	BRA	PR108_2		try again
;
PR108_4	MOVE.L	(A0),D1	position of file or -1
	BMI	PR_E81	----> no MACL label
	BCLR	#31,D7	ID
	MOVEA.L	D7,A0
	MOVEQ	#-1,D3
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	BRA	PR81_2	now do END_IF
;
; DCB <number>,<constant>
;
PR109	SUBQ.L	#2,A5
	MOVE.W	D1,D3	keep size
	BSR	GNUM	get <number>
	SUBQ.L	#1,D1
	BNE	PR_E1	---->
	MOVE.L	D2,D7	keep count in D7.L
	CMPI.B	#',',D0
	BNE	PR_E19	---->	comma expected
	PEA	PR109_1
	BRA	PR24_AG1	get <constant> via PR24
;
PR109_1	SUBQ.L	#1,D1
	BEQ	PR109_N	B, W or L
	ADDQ.L	#4,D1
	BEQ	PR109_F	S, D, X or P
	ADDQ.L	#1,D1
	BNE	PR109_ST	might be string
;
; Quad word (and S)
;
PR109_Q	MOVEQ	#3,D6		to count 8 bytes . .
	LEA	4+BUF(A6),A2	. . from BUF + 4
	BRA	PR109_X1
;
PR109_X	MOVEQ	#5,D6		to count 12 bytes . .
	LEA	BUF(A6),A2	. . from BUF
	LEA	(A5,D7.L*4),A5
PR109_X1	LEA	(A5,D7.L*8),A5
	BRA	PR109_X2
;
PR109_X5	SWAP	D7
PR109_X3	MOVEA.L	A2,A0		point to start of number
	MOVE.W	D6,D2		set count of bytes
PR109_X4	MOVE.W	(A0)+,D5
	BSR	PUT_W
	DBF	D2,PR109_X4
PR109_X2	DBF	D7,PR109_X3
	SWAP	D7
	DBF	D7,PR109_X5
	BRA	INST_ED1
;
; B W L
;
PR109_N	LEA	PR109_T1,A0
PR109_N1	SUBQ.W	#3,D3	B to L -> -3 TO -1
	BPL	PR_E1	---->
	ADDA.W	6(A0,D3.W*2),A0
	JMP	(A0)
;
; A string constant?
;
PR109_ST	SUBQ.L	#2,D1
	BNE	PR_E1	---->
	LEA	BUF(A6),A2
	MOVE.W	(A2)+,D2	string length
	BEQ	PR_E1	---->
	LEA	PR109_T3,A0	jump table
	BRA	PR109_N1
;
PR109_T1	DC.W	PR109_B-PR109_T1
	DC.W	PR109_W-PR109_T1
	DC.W	PR109_L-PR109_T1
;
PR109_T3	DC.W	PR109_BA-PR109_T3
	DC.W	PR109_WA-PR109_T3
	DC.W	PR109_LA-PR109_T3
;
PR109_B	BSR	CMP_B
	BMI	PR_E2	---->
PR109_B4	MOVE.B	D2,D5
	ROR.W	#8,D5	repeat the byte . .
	MOVE.B	D2,D5	. . in D5.W
	ADDA.L	D7,A5	set PC
	LSR.L	#1,D7
	BCC	PR109_B1	count was even
	BSR	PUT_B	put the odd byte
	BRA	PR109_B1
;
PR109_B3	SWAP	D7
PR109_B2	BSR	PUT_W	put 2 bytes
PR109_B1	DBF	D7,PR109_B2
	SWAP	D7
	DBF	D7,PR109_B3
	BRA	INST_ED1
;
PR109_W	BSR	CMP_W
	BMI	PR_E2	--->
	MOVE.W	D2,D5
PR109_W1	LEA	(A5,D7.L*2),A5	set PC
	BRA	PR109_B1
;
PR109_L	MOVE.L	D2,D5
PR109_L3	LEA	(A5,D7.L*4),A5
	BRA	PR109_L1
;
PR109_L4	SWAP	D7
PR109_L2	SWAP	D5
	BSR	PUT_W
	SWAP	D5
	BSR	PUT_W
PR109_L1	DBF	D7,PR109_L2
	SWAP	D7
	DBF	D7,PR109_L4
	BRA	INST_ED1
;
PR109_BA	SUBQ.W	#1,D2
	BNE	PR_E1	---->
	MOVE.B	(A2),D2
	BRA	PR109_B4
;
PR109_WA	SUBQ.W	#2,D2
	BGT	PR_E1	---->
	MOVE.W	(A2),D5
	BRA	PR109_W1
;
PR109_LA	SUBQ.W	#4,D2
	BGT	PR_E1	---->
	MOVE.L	(A2),D5
	BRA	PR109_L3
;
; FP numbers - D3 should be 11 to 14 only
;
PR109_F	SUBI.W	#11,D3
	BMI	PR_E16	---->
	CMPI.W	#3,D3
	BGT	PR_E16	---->
	LEA	BUF(A6),A0	set A0 for SRs FP_X..
	LEA	PR109_T2,A2
	ADDA.W	(A2,D3.W*2),A2
	JMP	(A2)
;
PR109_T2	DC.W	PR109_S-PR109_T2	S
	DC.W	PR109_D-PR109_T2	D
	DC.W	PR109_X-PR109_T2	X
	DC.W	PR109_P-PR109_T2	P
;
PR109_S	BSR	FP_XS
	MOVE.L	8+BUF(A6),D5
	BRA	PR109_L3
;
PR109_D	BSR	FP_XD
	BRA	PR109_Q
;
PR109_P	BSR	FP_XP
	BRA	PR109_X
;
; LIST (D7.W = 0), NOLIST (D7.L = $80000000)
;
PR110	SUBQ.L	#2,A5
	MOVE.L	LINE_NO(A6),D4
	OR.L	D7,D4		set marker for DIP bit 5
	MOVEQ	#0,D7		prepare for a new chain
	MOVE.L	PRL(A6),D3	pointer to chain
	BEQ	PR110_1		start a chain
PR110_2	MOVE.L	D3,D2
	MOVE.L	(D2.L),D3		move along the chain . .
	BNE	PR110_2		. . more to come
	MOVEQ	#1,D7		mark 'chain exists'
	MOVEA.L	4(D2.L),A2	pointer to next space
	MOVEA.L	D2,A0
	LEA	PRL_INC_S(A0),A0	-> end
	CMPA.L	A0,A2
	BLT	PR110_3		there is room
PR110_1	MOVE.L	#PRL_INC_S,D1
	BSR	NN_LG2		get space for another chunk
	BNE	QER4	---->	Out of space
	TST.L	D7
	BEQ	PR110_4		new chain
	MOVE.L	A0,(D2.L)		set new chunk address in old chunk
	BRA	PR110_5
PR110_4	MOVE.L	A0,PRL(A6)	set address of first chunk
PR110_5	LEA	12(A0),A0		point to second Line no
	MOVE.L	A0,-8(A0)		set pointer in chunk
	MOVE.L	D4,-4(A0)		put in the first Line no
	BRA	INST_ED1		finished
;
PR110_3	MOVE.L	D4,(A2)		set Line no
	ADDQ.L	#4,4(D2.L)	advance pointer
	BRA	INST_ED1		finished
